<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');
require_once APPPATH . 'libraries/sms/lib/AdnSmsNotification.php';

use AdnSms\AdnSmsNotification;

class Agent extends MX_AgentController
{

	function __construct()
	{
		parent::__construct();
		$live_agent_queue_array = $this->agent_model->live_agent_queue();
		$this->live_agent_queue_array = array();
		if (count($live_agent_queue_array)) {
			$this->live_agent_queue_array = $live_agent_queue_array;
		}
	}

	public function getAgentLiveRequest()
	{
		$callType = "";
		$agentStatus = "";
		$crm = 0;
		$callInfoForm = "";
		$crmForm = '';
		$inboundQueueCallList = "";
		$call_history_view = "";
		$dispositionForm = '';
		$emailView = '';
		$currentAgentStatus = $this->agent_model->agent_status_for_live();

		//check agent is ready status
		if ($currentAgentStatus['status'] === 'READY') {
			$this->data['site_settings'] = $this->ion_auth->site_settings();
			/*if (is_null($currentAgentStatus['calling_status'])) {
				$nextAgent = $this->agent_model->getNextAgent();
				if ($currentAgentStatus['id'] == $nextAgent->id) {
					$this->data['details'] = $this->agent_model->mail_unread_last();
					if ($this->data['details']) {
						$makeRead = $this->agent_model->mail_read($this->data['details']['id']);
						$this->agent_model->update_agent_calling_status("EMAIL", date('Y-m-d H:i:s'));
						$this->data['mail_attachments'] = $this->agent_model->mail_attachments($this->data['details']['id']);
						$emailView .= $this->load->view('email_receive_reply', $this->data, TRUE);
					}
				}
			}*/

			//check agent have any call in cdr tmp
			$getAgentInboundCall = $this->agent_model->getAgentInboundCall();

			//check caller/agent hangup call in cdr tmp
			//$getAgentInHangupCall = $this->agent_model->getAgentInHangupCall();
			//if any call in cdr tmp
			if ($getAgentInboundCall && $getAgentInboundCall['status'] == 1) {
				//check agent queue id of current call is exist in agent queue array
				if (in_array($getAgentInboundCall['queue_id'], $this->live_agent_queue_array)) {
					$callType = "INBOUND";
					$this->data['dst'] = $getAgentInboundCall['agent'];
					$this->data['src'] = $getAgentInboundCall['caller'];
					$this->data['hunting_number'] = $getAgentInboundCall['receiver'];
					$this->data['uid'] = $getAgentInboundCall['uniqid'];
					$this->data['campaign_name'] = $getAgentInboundCall['campaign_name'];
					$this->data['queue_name'] = $getAgentInboundCall['queue_name'];
					//call history start
					if (strlen($getAgentInboundCall['caller']) == 10) {
						if (substr($getAgentInboundCall['caller'], 1, 1) != '0') {
							$callHistorySrc = '0' . $getAgentInboundCall['caller'];
						} else {
							$callHistorySrc = $getAgentInboundCall['caller'];
						}
					} else {
						$callHistorySrc = $getAgentInboundCall['caller'];
					}
					$this->data['callHistory'] = $this->agent_model->call_history($callHistorySrc);
					if (count($this->data['callHistory'])) {
						$this->data['disposition_array'] = getRecordArray('dispositions', 'id', 'disposition_name', 'status=1');
						$this->data['queue_array'] = getRecordArray('queue', 'id', 'name');
						$call_history_view .= $this->load->view('call_history_view', $this->data, TRUE);
					}

					//call history end
					if ($this->data['site_settings']['crm'] == 1) {
						if ($this->data['site_settings']['crm_type'] == "INHOUSE") {
							//process agent live call start
							$crm = 1;

							$this->data['crmDetails'] = $this->agent_model->getCrmClientDetails($this->data['src']);
							if ($this->data['crmDetails']) {
								$view = 'client_update';
							} else {
								$view = 'client_add';
							}
							$crmForm .= $this->load->view($view, $this->data, TRUE);
							//process agent live call end
						} elseif ($this->data['site_settings']['crm_type'] == "BASIC") {
							//process agent live call start
							$crm = 1;
							if (strlen($this->data['src']) == 10) {
								if (substr($this->data['src'], 0, 1) != 0) {
									$this->data['src'] = "0" . $this->data['src'];
								}
							}
							$this->data['crmBasic'] = $this->agent_model->getCrm($this->data['src']);
							if ($this->data['crmBasic']) {
								$this->data['formaction'] = 'update';
								$this->data['myCalls'] = $this->agent_model->client_call_history($this->data['crmBasic']->id);
							} else {
								$this->data['formaction'] = 'add';
								$this->data['myCalls'] = array();
							}
							$view = "crm_basic";
							$crmForm .= $this->load->view($view, $this->data, TRUE);
							//process agent live call end
						} elseif ($this->data['site_settings']['crm_type'] == "IFRAME") {
							//process agent live call start
							$crm = 1;
							$view = 'crm_iframe';
							$this->data['datetime'] = date('j-F-Y', strtotime($getAgentInboundCall['call_time']));
							$this->data['datetime'] = strtolower($this->data['datetime']);
							$this->data['mobile'] = $getAgentInboundCall['caller'];
							$this->data['uniqueid'] = $getAgentInboundCall['uniqid'];
							$this->data['userid'] = $this->agent_model->get_inbound_agentname($getAgentInboundCall['agent']);
							if (isset($this->data['userid'])) {
								$this->data['userid'] = $this->data['userid']->agent_id;
							} else {
								$this->data['userid'] = "";
							}
							$this->data['crm_url'] = $this->data['site_settings']['crm_url'];
							$this->data['paramProcess'] = $this->getParamProcess($this->data['datetime'], $this->data['mobile'], $this->data['uniqueid']);
							$crmForm .= $this->load->view($view, $this->data, TRUE);

							//process agent live call end
						}
					}

					//calculate duration start
					$this->data['live_call_interval'] = $this->calculate_interval($getAgentInboundCall['call_time']);
					//calculate duration end
					$this->data['callStatus'] = $callType;

					$getQueueCall = $this->agent_model->getQueueCall();
					$getIVRCall = $this->agent_model->getIVRCall();
					$this->data['queueCallsCount'] = $getQueueCall;
					$this->data['ivrCallsCount'] = $getIVRCall;

					$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
					$this->agent_model->update_agent_calling_status("INCALL", $getAgentInboundCall['call_time']);
					echo json_encode(array("call_history_view" => $call_history_view, "agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "crmForm" => $crmForm, "uid" => $this->data['uid'], "callInfoForm" => $callInfoForm, "crm" => $crm));
				} else {
					$callType = "NOTINQUEUE";
					echo json_encode(array("agentStatus" => $currentAgentStatus['status'], "callType" => $callType));
				}
			} elseif ($getAgentInboundCall && $getAgentInboundCall['status'] == 0) {
				$callType = "INHANGUP";
				//$this->hangupagentcallfile();
				//if ($getAgentInHangupCall) {
				$dispositionForm = $this->getDispositionForm($getAgentInboundCall['uniqid']);
				//}
				$this->agent_model->update_agent_calling_status("INCALL-DISPOSITION", $getAgentInboundCall['call_end_time']);
				echo json_encode(array("agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "disposForm" => $dispositionForm, "dispo_timeout" => $this->data['callcenter_settings']['dispo_timeout']));
			} else {
				$callType = "NOCALL";
				$this->data['callStatus'] = $callType;

				$getQueueCall = $this->agent_model->getQueueCall();
				$getIVRCall = $this->agent_model->getIVRCall();
				$this->data['queueCallsCount'] = $getQueueCall;
				$this->data['ivrCallsCount'] = $getIVRCall;

				$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
				echo json_encode(array("emailView" => $emailView, "agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "callInfoForm" => $callInfoForm));
			}
		} //check agent is pause status
		elseif ($currentAgentStatus['status'] === 'PAUSE') {
			$callType = "NOCALL";
			//check inbound call list in cdr tmp
			if (count($this->live_agent_queue_array)) {
				$getInboundCallList = $this->agent_model->getInboundCallList($this->live_agent_queue_array);
			} else {
				$getInboundCallList = array();
			}

			//check agent have any outbound call in cdr tmp
			$getOutboundAgentCall = $this->agent_model->getOutboundAgentCall();
			//check caller/agent outbound hangup call in cdr tmp
			if ($getOutboundAgentCall && $getOutboundAgentCall['status'] == 4) {
				$callType = "OUTRINGGING";
				$this->data['dst'] = $getOutboundAgentCall['agent'];
				$this->data['src'] = $getOutboundAgentCall['caller'];
				$this->data['hunting_number'] = $getOutboundAgentCall['receiver'];
				$this->data['campaign_name'] = $getOutboundAgentCall['campaign_name'];
				$this->data['queue_name'] = $getOutboundAgentCall['queue_name'];
				$this->data['callStatus'] = $callType;
				$this->data['live_call_interval'] = $this->calculate_interval($getOutboundAgentCall['call_time']);

				$getQueueCall = $this->agent_model->getQueueCall();
				$getIVRCall = $this->agent_model->getIVRCall();
				$this->data['queueCallsCount'] = $getQueueCall;
				$this->data['ivrCallsCount'] = $getIVRCall;

				$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
				$this->agent_model->update_agent_calling_status("OUTCALL", $getOutboundAgentCall['call_time']);
				echo json_encode(array("inboundQueueCallList" => $inboundQueueCallList, "agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "callInfoForm" => $callInfoForm));
			} //if any outbound call in cdr tmp
			elseif ($getOutboundAgentCall && $getOutboundAgentCall['status'] == 3) {
				//if (count($getInboundCallList)) {
				//	$callType = "OUTLISTCALL";
				//} else {
				$callType = "OUTCALL";
				//process outbound call crm start
				$this->data['dst'] = $getOutboundAgentCall['agent'];
				$this->data['src'] = $getOutboundAgentCall['caller'];
				$this->data['hunting_number'] = $getOutboundAgentCall['receiver'];
				$this->data['campaign_name'] = $getOutboundAgentCall['campaign_name'];
				$this->data['queue_name'] = $getOutboundAgentCall['queue_name'];
				$this->data['uid'] = $getOutboundAgentCall['uniqid'];

				/*if ($this->data['site_settings']['crm'] == 1) {
					$this->data['crmDetails'] = $this->agent_model->getCrmClientDetails($this->data['src']);
					if ($this->data['crmDetails']) {
						$view = 'client_update';
					} else {
						$view = 'client_add';
					}
					$crmForm .= $this->load->view($view, $this->data, TRUE);
					//process outbound call crm end
				}*/
				$this->data['callStatus'] = $callType;
				$this->data['live_call_interval'] = $this->calculate_interval($getOutboundAgentCall['call_time']);

				$getQueueCall = $this->agent_model->getQueueCall();
				$getIVRCall = $this->agent_model->getIVRCall();
				$this->data['queueCallsCount'] = $getQueueCall;
				$this->data['ivrCallsCount'] = $getIVRCall;

				$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
				$this->agent_model->update_agent_calling_status("OUTCALL", $getOutboundAgentCall['call_time']);
				echo json_encode(array("inboundQueueCallList" => $inboundQueueCallList, "agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "crmForm" => $crmForm, "uid" => $this->data['uid'], "callInfoForm" => $callInfoForm, "crm" => $crm));
				//}
			} elseif ($getOutboundAgentCall && $getOutboundAgentCall['status'] == 0) {
				$callType = "OUTHANGUP";
				//	$this->hangupagentcallfile();
				//if ($getAgentOutHangupCall) {
				$dispositionForm = $this->getDispositionForm($getOutboundAgentCall['uniqid']);
				//}
				$this->data['callStatus'] = $callType;
				$this->agent_model->update_agent_calling_status("OUTCALL-DISPOSITION", $getOutboundAgentCall['call_end_time']);

				$getQueueCall = $this->agent_model->getQueueCall();
				$getIVRCall = $this->agent_model->getIVRCall();
				$this->data['queueCallsCount'] = $getQueueCall;
				$this->data['ivrCallsCount'] = $getIVRCall;

				$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
				echo json_encode(array("agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "disposForm" => $dispositionForm, "callInfoForm" => $callInfoForm, "dispo_timeout" => $this->data['callcenter_settings']['dispo_timeout']));
			} elseif (count($getInboundCallList)) {
				$this->data['controller'] = $this;
				$callType = "LISTCALL";
				$this->data['queueCalls'] = $getInboundCallList;
				$inboundQueueCallList .= $this->load->view('call_queue', $this->data, TRUE);
				$this->data['callStatus'] = $callType;

				$getQueueCall = $this->agent_model->getQueueCall();
				$getIVRCall = $this->agent_model->getIVRCall();
				$this->data['queueCallsCount'] = $getQueueCall;
				$this->data['ivrCallsCount'] = $getIVRCall;

				$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
				echo json_encode(array("agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "inboundQueueCallList" => $inboundQueueCallList, "callInfoForm" => $callInfoForm));
			} else {
				$callType = "NOCALL";
				//$callInfoForm = date('Y-m-d H:i:s');
				//echo json_encode(array("emailView" => $emailView, "agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "callInfoForm" => $callInfoForm));
				$this->data['callStatus'] = $callType;

				$getQueueCall = $this->agent_model->getQueueCall();
				$getIVRCall = $this->agent_model->getIVRCall();

				$this->data['queueCallsCount'] = $getQueueCall;
				$this->data['ivrCallsCount'] = $getIVRCall;

				$callInfoForm .= $this->load->view('call_info', $this->data, TRUE);
				echo json_encode(array("agentStatus" => $currentAgentStatus['status'], "callType" => $callType, "callInfoForm" => $callInfoForm));
			}
		} else {
		}
	}

	protected function getParamProcess($date = "", $mobile = "", $uid = "")
	{
		$totalSum = 0;
		$monthArray = array(
			"january" => 1,
			"february" => 2,
			"march" => 3,
			"april" => 4,
			"may" => 5,
			"june" => 6,
			"july" => 7,
			"august" => 8,
			"september" => 9,
			"october" => 10,
			"november" => 11,
			"december" => 12,
		);
		$dateRaw = explode("-", $date);
		$day = $dateRaw[0];
		$month = $monthArray[$dateRaw[1]];
		$year = $dateRaw[2];
		$dateSum = $day + $month + $year;

		$rawUid = explode(".", $uid);
		$uid1 = $rawUid[0];
		$uid2 = $rawUid[1];
		$uidSum = $uid1 + $uid2;

		$mobileSum = ltrim($mobile, "0");

		$totalSum = (int)$dateSum + (int)$mobileSum + (int)$uidSum;
		return $totalSum;
	}

	public function crm_save()
	{
		$crmDetails = '';
		$crmForm = '';
		$this->data['myCalls'] = array();
		$name = $this->input->post('name');
		$uid = $this->input->post('uid');
		$formaction = $this->input->post('formaction');
		$client_note = $this->input->post('client_note');
		$email = $this->input->post('email');
		$phone = $this->input->post('phone');
		$address = $this->input->post('address');
		$crm_id = $this->input->post('crm_id');
		if (strlen($phone) == 10) {
			if (substr($phone, 0, 1) != 0) {
				$phone = "0" . $phone;
			}
		}

		if ($formaction == 'add') {
			if ($name != '' && $phone != '') {
				$datas = array();
				$datas['name'] = $name;
				$datas['email'] = $email;
				$datas['address'] = $address;
				$datas['created_by'] = $this->session->userdata('user_id');
				$datas['phone'] = $phone;

				$insert_id = $this->db->insert('clients', $datas);
				if ($this->db->affected_rows()) {
					$dataNote = array();
					$dataNote['phone'] = $phone;
					$dataNote['uid'] = $uid;
					$dataNote['client_note'] = $client_note;
					$dataNote['client_id'] = $insert_id;
					$dataNote['created_by'] = $this->session->userdata('user_id');
					$this->db->insert('client_notes', $dataNote);

					$crmDetails = $this->agent_model->getCrm($phone);
					$this->data['crmClientNoteDetails'] = $this->agent_model->getClientNote($uid);
					$this->data['crmBasic'] = $crmDetails;
					$this->data['myCalls'] = $this->agent_model->client_call_history($this->data['crmBasic']->id);
					$view = "crm_basic_current";
					$crmForm .= $this->load->view($view, $this->data, TRUE);
					echo json_encode(array("crm_save" => 1, "crm_details" => $crmDetails, "crmForm" => $crmForm));
				} else {
					echo json_encode(array("crm_save" => 0, "crm_details" => $crmDetails));
				}
			} else {
				echo json_encode(array("crm_save" => 0, "crm_details" => $crmDetails));
			}
		} elseif ($formaction == 'update') {
			if ($name != '' && $phone != '') {
				$datas = array();
				$datas['name'] = $name;
				$datas['email'] = $email;
				$datas['address'] = $address;
				$datas['updated_by'] = $this->session->userdata('user_id');
				$datas['updated_on'] = date('Y-m-d H:i:s');

				$this->db->where('id', $crm_id);
				$this->db->update('clients', $datas);
				if ($this->db->affected_rows()) {
					$crmClientNoteDetails = $this->agent_model->getClientNote($uid);
					if ($crmClientNoteDetails) {
						$dataNote = array();
						$dataNote['client_note'] = $client_note;
						$dataNote['updated_by'] = $this->session->userdata('user_id');
						$this->db->where('uid', $uid);
						$this->db->update('client_notes', $dataNote);
					} else {
						$dataNote = array();
						$dataNote['phone'] = $phone;
						$dataNote['uid'] = $uid;
						$dataNote['client_note'] = $client_note;
						$dataNote['client_id'] = $crm_id;
						$dataNote['created_by'] = $this->session->userdata('user_id');
						$this->db->insert('client_notes', $dataNote);
					}
					$crmDetails = $this->agent_model->getCrm($phone);
					//
					$this->data['crmBasic'] = $crmDetails;
					$this->data['crmClientNoteDetails'] = $this->agent_model->getClientNote($uid);
					$this->data['myCalls'] = $this->agent_model->client_call_history($this->data['crmBasic']->id);
					$view = "crm_basic_current";
					$crmForm .= $this->load->view($view, $this->data, TRUE);
					//
					echo json_encode(array("crm_save" => 1, "crm_details" => $crmDetails, "crmForm" => $crmForm));
				} else {
					echo json_encode(array("crm_save" => 0, "crm_details" => $crmDetails));
				}
			} else {
				echo json_encode(array("crm_save" => 0, "crm_details" => $crmDetails));
			}
		} else {
			$crmDetails = $this->agent_model->getCrm($phone);

			$dataNote = array();
			$dataNote['phone'] = $phone;
			$dataNote['uid'] = $uid;
			$dataNote['client_note'] = $client_note;
			$dataNote['client_id'] = $crmDetails->id;
			$dataNote['created_by'] = $this->session->userdata('user_id');
			$this->db->insert('client_notes', $dataNote);
			echo json_encode(array("crm_save" => 1, "crm_details" => $crmDetails));
		}

	}

	function getNewTicket()
	{
		$newTicketForm = "";
		$phn = $this->input->post('phn');
		$this->data['department_opt'] = $this->ion_auth_model->get_department_array();
		$this->data['crmDetails'] = $this->agent_model->getCrmClientDetails($phn);
		$newTicketForm .= $this->load->view('new_ticket', $this->data, TRUE);
		echo json_encode(array("new_ticket_form" => $newTicketForm));
	}

	public function connect_asterisk($command = "")
	{
		$this->load->library('Asm_manager');
		$asm = new AGI_AsteriskManager();
		if ($asm->connect()) {
			if ($command != '') {
				if ($command === "sip show peers") {
					$extensionInfo = $asm->Command($command);
					foreach (explode("\n", $extensionInfo['data']) as $line) {

						if (preg_match("/OK/i", $line) || preg_match("/UNKNOWN/i", $line)) {
							$extensionFilterData = array_values(array_filter(explode(' ', $line)));
							if ($extensionFilterData[2] == 'D') {
								$extensionArray[] = $extensionFilterData;
							}
						}
					}
					return $extensionArray;
				}
			}
		}
	}

	public function closeLiveState()
	{
		if ($this->session->has_userdata('pause_request')) {
			$this->session->unset_userdata('pause_request');
			$this->session->unset_userdata('pause_id');
		}
		$extension = $this->session->userdata('extension');
		$campaign = $this->session->userdata('campaign');
		//agent queue number remove start
		$this->db->where('number', $extension);
		$this->db->delete('queue_numbers');
		/*if ($this->db->affected_rows()) {
			$this->createQueuefile();
		}*/
		//agent queue number remove end

		$this->agent_model->change_agent_status();
		$this->exitagentcallfile();
		//		//tmp_agent_status remove start
		//		$this->db->where('extension', $extension);
		//		$this->db->delete('tmp_agent_status');
		//		//tmp_agent_status remove end
		echo json_encode(array("result" => "OK"));
	}

	public function dualSelect()
	{
		$this->data['queues_opt'] = array();
		$this->data['selected_queues_opt'] = array();
		$extension = $this->session->userdata('extension');
		$campaign = $this->session->userdata('campaign');
		$this->data['queues_opt'] = $this->agent_model->get_campaign_queue_array($campaign);
		$selected_campaign_queues = $this->agent_model->selected_campaign_queues($extension);
		if ($selected_campaign_queues) {
			$tmpResult = array();
			foreach ($selected_campaign_queues as $campaign_queues) {
				$queue_details = $this->agent_model->get_queue_details($campaign_queues->queue_id);
				$tmpResult[$queue_details['name']] = $queue_details['name'];
			}
			$this->data['selected_queues_opt'] = $tmpResult;
		}
		$result = $this->load->view('dual_select', $this->data, TRUE);
		$agent_status = $this->agent_model->agent_status();
		$agent_status = $agent_status['status'];
		echo json_encode(array("result" => $result, "agent_status" => $agent_status));
	}

	public function getDispositionForm($calluid = '')
	{
		//$this->data['calluid'] = $this->input->post('calluid');
		$this->data['calluid'] = $calluid;

		$this->data['disposition_opt'] = $this->ion_auth_model->get_disposition_array();
		$dispos_form = '';
		$dispos_form .= $this->load->view('disposition_add', $this->data, TRUE);
		return $dispos_form;
		//echo json_encode(array("dispos_form" => $dispos_form));
	}

	public function send_sms_adn()
	{
		$mobile = $this->input->post('recipient');
		$rawMessage = $this->input->post('message');

		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));

		//$mobile = '88' . '01777770287';
		//$message = "hello test";

		$recipient = $mobile;       // For SINGLE_SMS or OTP
		$requestType = 'SINGLE_SMS';    // options available: "SINGLE_SMS", "OTP"
		$messageType = 'TEXT';

		$sms = new AdnSmsNotification();
		$response = $sms->sendSms($requestType, $message, $recipient, $messageType);
//		echo "<pre>";
//		print_r($response);
//		exit;
		$response = json_decode($response, true);
		$smsLog = array();
		$smsLog['message'] = $rawMessage;
		$smsLog['mobiles'] = $mobile;
		$smsLog['request_type'] = $response['request_type'];
		$smsLog['campaign_uid'] = $response['campaign_uid'];
		$smsLog['sms_uid'] = $response['sms_uid'];
		$smsLog['api_response_code'] = $response['api_response_code'];
		$smsLog['api_response_message'] = $response['api_response_message'];
		$smsLog['created_by'] = $this->session->userdata('user_id');

		$this->db->insert('adn_sms_log', $smsLog);

		echo json_encode(array("send" => $response['api_response_message']));
	}

	public function send_sms()
	{
		$mobiles = $this->input->post('recipient');
		$rawMessage = $this->input->post('message');

		$response = $this->btcl_api($mobiles, $rawMessage);

		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));
		$smsLog = array();
		$smsLog['message'] = $rawMessage;
		$smsLog['mobiles'] = $mobiles;
		$smsLog['status'] = $response['status'];
		$smsLog['scode'] = $response['scode'];
		$smsLog['details'] = $response['details'];
		$smsLog['server'] = $response['server'];
		$smsLog['sms_class'] = $response['sms_class'];
		$smsLog['processing_details'] = $response['processing_details'];
		$smsLog['credit_deducted'] = (int)$response['credit_deducted'];
		$smsLog['current_credit'] = (int)$response['current_credit'];
		$smsLog['current_credit_master'] = $response['current_credit_master'];
		$smsLog['credit_inheritance'] = $response['credit_inheritance'];
		$smsLog['chunk_id'] = (int)$response['chunk_id'];
		$smsLog['cid'] = $response['cid'];
		$smsLog['created_by'] = $this->session->userdata('user_id');

		$this->db->insert('btcl_sms_log', $smsLog);

		/*$mobile = '88' . '01777770287';
		$message = "hello test";

		$recipient = $mobile;       // For SINGLE_SMS or OTP
		$requestType = 'SINGLE_SMS';    // options available: "SINGLE_SMS", "OTP"
		$messageType = 'TEXT';

		$sms = new AdnSmsNotification();
		$response = $sms->sendSms($requestType, $message, $recipient, $messageType);
		echo "<pre>";
		print_r($response);
		exit;
		$response = json_decode($response, true);*/

		echo json_encode(array("send" => $response['status']));
	}

	public function send_sms_jk()
	{
		$mobiles = $this->input->post('recipient');
		$rawMessage = $this->input->post('message');

		$response = $this->jk_sms_api($mobiles, $rawMessage);

		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));
		$smsLog = array();
		$smsLog['message'] = $rawMessage;
		$smsLog['mobiles'] = $mobiles;
		$smsLog['message_id'] = isset($response['message_id']) ? $response['message_id'] : null;
		$smsLog['api_response_code'] = $response['response_code'];
		$smsLog['api_success_message'] = $response['success_message'];
		$smsLog['api_error_message'] = $response['error_message'];
		$smsLog['created_by'] = $this->session->userdata('user_id');

		$this->db->insert('jk_sms_log', $smsLog);

		echo json_encode(array("send" => "SUCCESS"));
	}

	public function send_sms_sibl()
	{
		$send = "FAILED";
		$mobile = $this->input->post('recipient');
		$rawMessage = $this->input->post('message');

		$response = $this->sibl_sms_api($mobile, $rawMessage);
		//echo "<pre>";
		//print_r($response);
		//exit;
		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));
		$smsLog = array();
		$smsLog['message'] = $rawMessage;
		$smsLog['mobile'] = $mobile;
		$smsLog['message_id'] = isset($response['message_id']) ? $response['message_id'] : null;
		$smsLog['api_response_code'] = $response['response_code'];
		$smsLog['api_success_message'] = $response['success_message'];
		$smsLog['api_error_message'] = $response['error_message'];
		$smsLog['created_by'] = $this->session->userdata('user_id');

		$this->db->insert('sibl_sms_log', $smsLog);
		if (isset($response['responseCode']) && $response['responseCode'] == 200) {
			$send = "SUCCESS";
		} else {
			$send = "FAILED";
		}
		echo json_encode(array("send" => $send));
	}

	public function next()
	{
		$extension = $this->session->userdata('extension');
		$or = '';
		$selected_campaign_queues = $this->agent_model->selected_campaign_queues_lead($extension);
		if ($selected_campaign_queues) {
			$this->data['outbound_route_array'] = getRecordArray('outbound_route', 'id', 'title');
			$queue_details = $this->agent_model->get_queue_details($selected_campaign_queues['queue_id']);
			$or = isset($this->data['outbound_route_array'][$queue_details['outbound_id']]) ? $this->data['outbound_route_array'][$queue_details['outbound_id']] : '';
		}

		$dial_number_raw = $this->agent_model->next_contact();
		$dial_number = $dial_number_raw['contact_no'];
		$campaign = $this->session->userdata('campaign');
		$campaignName = campaignNameFromID($campaign);
		$agent_id = $this->session->userdata('user_userid');
		if ($or) {
			$out_routing = $or;
		} else {
			$out_routing = $this->session->userdata('out_route_name');
		}

		if (!empty($dial_number)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName:" . MANAGER_USER . "\r\n");
				fputs($socket, "Secret:" . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Originate\r\n");
				fputs($socket, "Channel: local/" . $dial_number . "@phones\r\n");
				fputs($socket, "Variable:trunknamenew=$out_routing\r\n");
				fputs($socket, "Context: agent_outbound\r\n");
				fputs($socket, "Exten: $extension\r\n");
				fputs($socket, "Priority: 1\r\n");
				fputs($socket, "Callerid: $extension\r\n");
				fputs($socket, "Variable:A_PARTY=$dial_number\r\n");
				fputs($socket, "Variable:agent=$extension\r\n");
				fputs($socket, "Variable:call_strategy=1\r\n");
				fputs($socket, "Variable:recording=0\r\n");
				fputs($socket, "Variable:caller_point_agent=0\r\n");
				fputs($socket, "Variable:campaign_id=" . $campaign . "\r\n");
				fputs($socket, "Variable:campaign_name=" . $campaignName . "\r\n");
				fputs($socket, "Variable:agent_id=" . $agent_id . "\r\n");
				fputs($socket, "Async: yes\r\n\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
			}
			sleep(2);
			fclose($socket);
			echo json_encode(array("status" => "SUCCESS", "dial" => $wrets));
		} else {
			echo json_encode(array("status" => "FAILED"));
		}
	}

	public function dial()
	{
		$queue_id = '';
		$agent_status = $this->agent_model->agent_status();
		if ($agent_status['pause_type_id'] != 8) {
			echo json_encode(array("dial" => "NO"));
		} else {
			$extension = $this->session->userdata('extension');
			$or = '';
			$queue_name = '';
			$selected_campaign_queues = $this->agent_model->selected_campaign_queues_lead($extension);
			if ($selected_campaign_queues) {
				$this->data['outbound_route_array'] = getRecordArray('outbound_route', 'id', 'title');
				$queue_id = $selected_campaign_queues['queue_id'];
				$queue_details = $this->agent_model->get_queue_details($selected_campaign_queues['queue_id']);
				$or = isset($this->data['outbound_route_array'][$queue_details['outbound_id']]) ? $this->data['outbound_route_array'][$queue_details['outbound_id']] : '';
				$queue_name = $queue_details['name'];
				if ($queue_id) {
					$queue_template_details = $this->agent_model->get_queue_template_details($queue_details['queue_template']);
				}
			}

			$dial_number = $this->input->post('dial_number');
			$campaign = $this->session->userdata('campaign');
			$campaignName = campaignNameFromID($campaign);
			$agent_id = $this->session->userdata('user_userid');
			if ($or) {
				$out_routing = $or;
			} else {
				$out_routing = $this->session->userdata('out_route_name');
			}
			if (!empty($dial_number)) {
				$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
				if (!$socket) {
				} else {
					fputs($socket, "Action: Login\r\n");
					fputs($socket, "UserName:" . MANAGER_USER . "\r\n");
					fputs($socket, "Secret:" . MANAGER_PWD . "\r\n\r\n");
					fputs($socket, "Action: Originate\r\n");
					fputs($socket, "Channel: local/" . $extension . "@agent\r\n");
					fputs($socket, "Variable:trunknamenew=$out_routing\r\n");
					fputs($socket, "Context: phones\r\n");
					fputs($socket, "Exten: $dial_number\r\n");
					fputs($socket, "Priority: 1\r\n");
					fputs($socket, "Callerid: $extension\r\n");
					fputs($socket, "Variable:A_PARTY=$dial_number\r\n");
					fputs($socket, "Variable:agent=$extension\r\n");
					fputs($socket, "Variable:call_strategy=1\r\n");
					fputs($socket, "Variable:recording=0\r\n");
					fputs($socket, "Variable:caller_point_agent=0\r\n");
					fputs($socket, "Variable:campaign_id=" . $campaign . "\r\n");
					fputs($socket, "Variable:campaign_name=" . $campaignName . "\r\n");
					fputs($socket, "Variable:queue_id= " . $queue_id . " \r\n");
					fputs($socket, "Variable:queue_name= " . $queue_name . " \r\n");
					fputs($socket, "Variable:agent_id=" . $agent_id . "\r\n");
					fputs($socket, "Variable:agent_name=" . $agent_id . "\r\n");
					fputs($socket, "Variable:queue_template=" . $queue_details['queue_template'] . "\r\n");
					fputs($socket, "Variable:musiconhold=" . $queue_template_details['musiconhold'] . "\r\n");
					fputs($socket, "Async: yes\r\n\r\n");
					fputs($socket, "Action: Logoff\r\n\r\n");

					$wrets = fgets($socket, 128);
				}
				sleep(2);
				fclose($socket);
				//echo json_encode(array("dial" => "YES", 'out_routing' => $out_routing, 'queue_name' => $queue_name, 'campaign' => $campaign));
				echo json_encode(array("musiconhold" => $queue_template_details['musiconhold'], "queue_template" => $queue_details['queue_template'], "dial" => "YES", 'out_routing' => $out_routing, 'queue_name' => $queue_name, 'campaign' => $campaign, "queue_id" => $queue_id));
			}
		}
	}

	public function menuAction()
	{
		$action = $this->input->post('action');
		$menu_view = '';
		if ($action == 'kp') {
			$this->load->model('faq/faq_model');
			$this->data['faqs'] = $this->faq_model->views();
			$menu_view .= $this->load->view('menu_faq_view', $this->data, TRUE);
		} elseif ($action == 'fc') {
			$startTime = "";
			$endTime = "";
			if ($this->data['callcenter_settings']['failed_report'] == 'OFFICE-TIME') {
				$startTime = $this->data['callcenter_settings']['office_start'];
				$endTime = $this->data['callcenter_settings']['office_end'];
			}
			$this->data['queue_array'] = getRecordArray('queue', 'id', 'name');
			$this->data['failedCalls'] = $this->agent_model->failed_call($startTime, $endTime);
			$menu_view .= $this->load->view('menu_failed_call_view', $this->data, TRUE);
		} elseif ($action == 'nb') {
			$this->data['notices'] = $this->agent_model->notices();
			$menu_view .= $this->load->view('menu_notice_view', $this->data, TRUE);
		} elseif ($action == 'sc') {
			$this->data['scheduleCalls'] = $this->agent_model->schedule_call();
			$menu_view .= $this->load->view('menu_schedule_call_view', $this->data, TRUE);
		} elseif ($action == 'kpi') {
			$this->data['my_others_summary'] = $this->agent_model->summary_my_others();
			$this->data['my_cdr_summary'] = $this->agent_model->summary_my_cdr();
			$menu_view .= $this->load->view('menu_my_cdr_summary_view', $this->data, TRUE);
		} elseif ($action == 'mc') {
			$this->data['myCalls'] = $this->agent_model->my_call();
			$menu_view .= $this->load->view('menu_my_call_view', $this->data, TRUE);
		} elseif ($action == 'sms') {
			$menu_view .= $this->load->view('menu_sms_view', $this->data, TRUE);
		} elseif ($action == 'email') {
			$menu_view .= $this->load->view('menu_email_view', $this->data, TRUE);
		} elseif ($action == 'chat') {
			$this->load->model('chat/chat_model');
			$this->data['loggedUser'] = $this->chat_model->get_logged_user_details();
			$this->data['chatUsers'] = $this->chat_model->get_chat_users();
			$this->data['getUserChat'] = $this->chat_model->getUserChat($this->session->userdata('user_id'), $this->data['loggedUser']['current_session']);
			$menu_view .= $this->load->view('menu_chat_view', $this->data, TRUE);
		}
		echo json_encode(array("menu_result" => $menu_view, "action" => $action));
	}

	public function client_save()
	{ //echo "<pre>"; print_r($_POST); exit;
		$crmDetails = '';
		$name = $this->input->post('name');
		$uid = $this->input->post('uid');
		$schedule_call = $this->input->post('schedule_call');
		$formaction = $this->input->post('formaction');
		$client_note = $this->input->post('client_note');
		$email = $this->input->post('email');
		$phone = $this->input->post('phone');
		$address = $this->input->post('address');

		if ($formaction == 'add') {
			if ($name != '' && $phone != '') {
				$datas = array();
				$datas['name'] = $name;
				$datas['email'] = $email;
				$datas['address'] = $address;
				$datas['created_by'] = $this->session->userdata('user_id');
				$datas['phone'] = $phone;

				$insert_id = $this->db->insert('clients', $datas);
				if ($this->db->affected_rows()) {
					$dataNote = array();
					$dataNote['phone'] = $phone;
					$dataNote['client_note'] = $client_note;
					$dataNote['client_id'] = $insert_id;
					$dataNote['created_by'] = $this->session->userdata('user_id');
					$dataNote['ip'] = $this->input->ip_address();
					$this->db->insert('client_notes', $dataNote);

					$crmDetails = $this->agent_model->getCrm($phone);
					echo json_encode(array("client_save" => 1, "crm_details" => $crmDetails));
				} else {
					echo json_encode(array("client_save" => 0, "crm_details" => $crmDetails));
				}
			} else {
				echo json_encode(array("client_save" => 0, "crm_details" => $crmDetails));
			}
		} else {
			$crmDetails = $this->agent_model->getCrm($phone);

			$dataNote = array();
			$dataNote['phone'] = $phone;
			if ($schedule_call == 'true') {
				$dataNote['schedule_call'] = 1;
			}
			$dataNote['uid'] = $uid;
			$dataNote['client_note'] = $client_note;
			$dataNote['client_id'] = $crmDetails->id;
			$dataNote['created_by'] = $this->session->userdata('user_id');
			$this->db->insert('client_notes', $dataNote);

			if ($schedule_call == 'true') {
				$temp_call = $this->agent_model->getTempCall($uid);
				if ($temp_call) {
					$temp_call_data = array();
					$temp_call_data['schedule_call'] = 1;

					$this->db->where('uniqid', $uid);
					$this->db->update('queue_cdr_tmp', $temp_call_data);
				}
				$schedule_call_data = array();
				$schedule_call_data['schedule_call'] = 1;

				$this->db->where('uniqueid', $uid);
				$this->db->update('queue_cdr', $schedule_call_data);
			}

			echo json_encode(array("client_save" => 1, "crm_details" => $crmDetails));
		}
	}


	public function create_ticket()
	{
		//echo "<pre>";
		//print_r($_POST);
		//exit;

		$datas['ticket_type'] = $this->input->post('ticket_type');
		$datas['ticket_subject'] = $this->input->post('ticket_subject');
		$datas['ticket_exp'] = $this->input->post('ticket_exp');
		$datas['etr'] = $this->input->post('etr');
		$datas['department'] = implode(',', $this->input->post('department'));
		$datas['priority'] = $this->input->post('priority');
		$datas['ticket_status'] = $this->input->post('ticket_status');
		$datas['created_by'] = $this->input->post('created_by');
		$datas['client_id'] = $this->input->post('client_id');
		$datas['branch_id'] = $this->input->post('branch_id');
		$datas['incident_time'] = $this->input->post('incident_time');
		$datas['source'] = $this->input->post('source');
		$datas['support_type'] = $this->input->post('support_type');

		$this->db->insert('tickets', $datas);
		//echo json_encode(array("client_save" => 1, "crm_details" => $crmDetails));
		if ($this->db->affected_rows() > 0) {
			echo json_encode(array("status" => 200));
		} else {
			echo json_encode(array("status" => 400));
		}


		//echo json_encode($_POST);
	}

	public function get_outbound_call()
	{
		$outboundCallLogForm = "";
		//show outbound history start
		$this->data['outboundCallLog'] = $this->agent_model->outbound_call_log();
		$outboundCallLogForm .= $this->load->view('outbound_call_log', $this->data, TRUE);
		//show outbound history end
		echo json_encode(array("outboundCallLogForm" => $outboundCallLogForm));
	}

	public function dispositionSubmit()
	{
		$pause_request = $this->session->pause_request;
		$pause_id = $this->session->pause_id;
		$agent_name = $this->session->userdata('name');
		$uid = $this->input->post('uid');
		$disposition_id = $this->input->post('disposition_id');
		$schedule_date = $this->input->post('schedule_date');

		$currentCallLog = $this->agent_model->current_call_log($uid);
		if ($currentCallLog) {
			//calculate duration start
			if ($this->data['callcenter_settings']['dispo_timeout'] == 1) {
				$disposition_interval = $this->calculate_interval($currentCallLog->end_call);
				$disposition_interval = $disposition_interval - 0;

				if ($disposition_interval > $this->data['callcenter_settings']['dispo_time']) {
					$disposition_interval = $this->data['callcenter_settings']['dispo_time'];
				} elseif ($disposition_interval <= 0) {
					$disposition_interval = 1;
				}
			} else {
				$disposition_interval = $this->calculate_interval($currentCallLog->end_call);
				$disposition_interval = $disposition_interval - 0;
				if ($disposition_interval <= 0) {
					$disposition_interval = 1;
				}
			}
			//calculate duration end

			$disposition_data = array();
			$disposition_data['disposition'] = $disposition_id;
			$disposition_data['dispos_time'] = date('Y-m-d H:i:s');
			$disposition_data['dispos_duration'] = $disposition_interval;
			if ($disposition_id == 2) {
				$disposition_data['schedule_call'] = 1;
				$disposition_data['schedule_call_time'] = $schedule_date;
			}

			$this->db->where('uniqueid', $uid);
			$this->db->update('queue_cdr', $disposition_data);
		} else {
			$getAltTempCall = $this->agent_model->getAltTempCall($uid);
			if ($getAltTempCall['call_type'] == 'IN') {
				//calculate duration start
				if ($this->data['callcenter_settings']['dispo_timeout'] == 1) {
					$disposition_interval = $this->calculate_interval($getAltTempCall['call_end_time']);
					$disposition_interval = $disposition_interval - 0;

					if ($disposition_interval > $this->data['callcenter_settings']['dispo_time']) {
						$disposition_interval = $this->data['callcenter_settings']['dispo_time'];
					} elseif ($disposition_interval <= 0) {
						$disposition_interval = 1;
					}
				} else {
					$disposition_interval = $this->calculate_interval($getAltTempCall['call_end_time']);
					$disposition_interval = $disposition_interval - 0;
					if ($disposition_interval <= 0) {
						$disposition_interval = 1;
					}
				}
				//calculate duration end

				$cdrData = array(
					"queue_id" => $getAltTempCall['queue_id'],
					"queue_name" => $getAltTempCall['queue_name'],
					"campaign_id" => $getAltTempCall['campaign_id'],
					"campaign_name" => $getAltTempCall['campaign_name'],
					"call_date" => $getAltTempCall['call_connect_time'],
					"start_call" => $getAltTempCall['call_time'],
					"end_call" => $getAltTempCall['call_end_time'],
					"duration" => $this->calculate_billsec_interval($getAltTempCall['call_time'], $getAltTempCall['call_end_time']),
					"billsec" => $this->calculate_billsec_interval($getAltTempCall['call_time'], $getAltTempCall['call_end_time']),
					"call_status" => "ANSWER",
					"status" => "answer",
					"try" => 0,
					"hunting_number" => $getAltTempCall['receiver'],
					"clid" => $getAltTempCall['caller'],
					"agent" => $getAltTempCall['agent'],
					"agent_id" => $agent_name,
					"hangup_by" => "CALLER",
					"term_reason" => "CALLER",
					"uniqueid" => $getAltTempCall['uniqid'],
					"linkedid" => $getAltTempCall['linkedid'],
					"direction" => $getAltTempCall['call_type'],
					"schedule_call" => ($disposition_id == 2) ? 1 : 0,
					"schedule_call_time" => ($disposition_id == 2) ? $schedule_date : null,
					"disposition" => $disposition_id,
					"dispos_time" => date('Y-m-d H:i:s'),
					"dispos_duration" => $disposition_interval,
					"data_insert_type" => 1
				);
				$this->db->insert('queue_cdr', $cdrData);
			} elseif ($getAltTempCall['call_type'] == 'OUT') {
				//calculate duration start
				if ($this->data['callcenter_settings']['dispo_timeout'] == 1) {
					$disposition_interval = $this->calculate_interval($getAltTempCall['call_end_time']);
					$disposition_interval = $disposition_interval - 0;

					if ($disposition_interval > $this->data['callcenter_settings']['dispo_time']) {
						$disposition_interval = $this->data['callcenter_settings']['dispo_time'];
					} elseif ($disposition_interval <= 0) {
						$disposition_interval = 1;
					}
				} else {
					$disposition_interval = $this->calculate_interval($getAltTempCall['call_end_time']);
					$disposition_interval = $disposition_interval - 0;
					if ($disposition_interval <= 0) {
						$disposition_interval = 1;
					}
				}
				//calculate duration end

				$cdrData = array(
					"queue_id" => $getAltTempCall['queue_id'],
					"queue_name" => $getAltTempCall['queue_name'],
					"campaign_id" => $getAltTempCall['campaign_id'],
					"campaign_name" => $getAltTempCall['campaign_name'],
					"call_date" => $getAltTempCall['call_connect_time'],
					"start_call" => $getAltTempCall['call_time'],
					"end_call" => $getAltTempCall['call_end_time'],
					"duration" => $this->calculate_billsec_interval($getAltTempCall['call_connect_time'], $getAltTempCall['call_end_time']),
					"billsec" => $this->calculate_billsec_interval($getAltTempCall['call_time'], $getAltTempCall['call_end_time']),
					"call_status" => "ANSWER",
					"status" => "answer",
					"try" => 0,
					"hunting_number" => $getAltTempCall['receiver'],
					"out_trunk" => $getAltTempCall['receiver'],
					"clid" => $getAltTempCall['caller'],
					"agent" => $getAltTempCall['agent'],
					"agent_id" => $agent_name,
					"hangup_by" => "CALLER",
					"term_reason" => "CALLER",
					"uniqueid" => $getAltTempCall['uniqid'],
					"linkedid" => $getAltTempCall['linkedid'],
					"direction" => $getAltTempCall['call_type'],
					"disposition" => $disposition_id,
					"dispos_time" => date('Y-m-d H:i:s'),
					"dispos_duration" => $disposition_interval,
					"data_insert_type" => 1
				);
				$this->db->insert('queue_cdr', $cdrData);
			}
		}

		if ($this->db->affected_rows()) {
			$getAgentHangCall = $this->agent_model->getAgentHangCall($uid);
			if ($getAgentHangCall) {
				$this->db->where('number', $getAgentHangCall['agent']);
				//$this->db->where('queue_id', $getAgentHangCall['queue_id']);
				$this->db->update('queue_numbers', array("status" => 0, "call_order_type" => 0, "call_time" => date('Y-m-d H:i:s')));
			} else {
				echo json_encode(array("update" => false));
			}
			$this->db->where('uniqid', $uid);
			$this->db->delete('queue_cdr_tmp');
			$this->agent_model->update_agent_calling_status();
			//
			//$currentCallLog = $this->agent_model->current_call_log($uid);
			$data = array();
			$data = array(
				'attend_date' => date('Y-m-d'),
				'agent_id' => $this->session->userdata('user_userid'),
				'agent_name' => $agent_name,
				'uniqueid' => $uid,
				'agent_status' => ($getAgentHangCall['call_type'] == "IN") ? 'DISPOSITION-IN' : 'DISPOSITION-OUT',
				'agent_sip' => $getAgentHangCall['agent'],
				'campaign' => $getAgentHangCall['campaign_id'],
				'queue_id' => $getAgentHangCall['queue_id'],
				'last_response_time' => date('Y-m-d H:i:s'),
				'duration' => $disposition_interval,
				'disposition_id' => $disposition_id,
				'ip' => $this->input->ip_address()
			);
			$this->db->insert('queue_agent_status', $data);
			//
			echo json_encode(array("pause_id" => $pause_id, "pause_request" => $pause_request, "update" => true, "dispo_timeout" => $this->data['callcenter_settings']['dispo_timeout']));
		} else {
			$getAgentHangCall = $this->agent_model->getAgentHangCall($uid);
			if ($getAgentHangCall) {
				$this->db->where('number', $getAgentHangCall['agent']);
				//$this->db->where('queue_id', $getAgentHangCall['queue_id']);
				$this->db->update('queue_numbers', array("status" => 0, "call_order_type" => 0, "call_time" => date('Y-m-d H:i:s')));
			}
			$this->db->where('uniqid', $uid);
			$this->db->delete('queue_cdr_tmp');
			$this->agent_model->update_agent_calling_status();
			echo json_encode(array("pause_id" => $pause_id, "pause_request" => $pause_request, "update" => false));
		}
	}


	public function getReady()
	{
		$agent_login_id = $this->session->userdata('agent_login_id');
		$agent_id = $this->session->userdata('user_userid');
		$agent_name = $this->session->userdata('name');
		$extension = $this->session->userdata('extension');
		$campaign = $this->session->userdata('campaign');
		$ready = 0;
		$queue_select = 0;
		if (count($this->live_agent_queue_array) > 0) {
			if ($campaign) {
				$data = array();
				$data = array(
					'attend_date' => date('Y-m-d'),
					'agent_id' => $agent_id,
					'agent_name' => $agent_name,
					'agent_status' => 'READY',
					'agent_sip' => $extension,
					'campaign' => $campaign,
					'last_response_time' => date('Y-m-d H:i:s'),
					'agent_login_id' => isset($agent_login_id) ? $agent_login_id : null,
					'ip' => $this->input->ip_address()
				);
				$this->db->insert('queue_agent_status', $data);
				//tmp_agent_status remove start
				$this->agent_model->change_agent_status("READY");
				if ($this->db->affected_rows()) {
					$this->agent_model->change_queue_number_status("inbound");
					//create queue file start
					//$this->createQueuefile();
					//create queue file end
				}

				$ready = 1;
				$queue_select = 1;
			}
			echo json_encode(array("agent_ready" => $ready, "queue_select" => $queue_select));
		} else {
			echo json_encode(array("agent_ready" => $ready, "queue_select" => $queue_select));
		}

	}

	public function getPause()
	{
		$outboundCallLogForm = "";
		$pauseName = "";
		if ($this->session->has_userdata('pause_request')) {
			$this->session->unset_userdata('pause_request');
			$this->session->unset_userdata('pause_id');
		}
		$agent_login_id = $this->session->userdata('agent_login_id');
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$agent_name = $this->session->userdata('name');
		$pause_type_id = $this->input->post('pause_type_id');
		$name = $this->session->userdata('name');
		$campaign = $this->session->userdata('campaign');
		$pause = 0;
		$getAgentInboundCall = $this->agent_model->getAgentInboundCall();
		if ($getAgentInboundCall && ($getAgentInboundCall['status'] == 1 || $getAgentInboundCall['status'] == 0)) {
			$this->session->set_userdata('pause_request', 'YES');
			$this->session->set_userdata('pause_id', $pause_type_id);
		} else {

			if ($campaign) {
				$this->agent_model->change_agent_status("PAUSE", $pause_type_id);
				if ($this->db->affected_rows()) {
					$this->agent_model->change_queue_number_status("pause");
				}
				//			//tmp_agent_status remove start
				//			$this->db->where('extension', $extension);
				//			$this->db->delete('tmp_agent_status');
				//			//tmp_agent_status remove end
				//			//tmp_agent_status add start
				//			$this->db->insert('tmp_agent_status', array('extension'=>$extension, 'status'=> "PAUSE", 'agent_id'=>$agent_id));
				//			//tmp_agent_status add end

				$pause = 1;

				//create queue file start
				//$this->createQueuefile();
				//create queue file end
				$data = array();
				$data = array(
					'attend_date' => date('Y-m-d'),
					'agent_id' => $agent_id,
					'agent_name' => $agent_name,
					'agent_status' => 'PAUSE',
					'agent_sip' => $extension,
					'pause_type_id' => $pause_type_id,
					'campaign' => $campaign,
					'last_response_time' => date('Y-m-d H:i:s'),
					'agent_login_id' => isset($agent_login_id) ? $agent_login_id : null,
					'ip' => $this->input->ip_address()
				);
				$this->db->insert('queue_agent_status', $data);
				$this->data['pause_type_array'] = getRecordArray('pause_type', 'id', 'name', 'status=1');
				$pauseName = isset($this->data['pause_type_array'][$pause_type_id]) ? " (" . $this->data['pause_type_array'][$pause_type_id] . ")" : '';
			}
		}
		//show outbound history start
		$this->data['outboundCallLog'] = $this->agent_model->outbound_call_log();
		$outboundCallLogForm .= $this->load->view('outbound_call_log', $this->data, TRUE);
		//show outbound history end
		echo json_encode(array("outboundCallLogForm" => $outboundCallLogForm, "agent_ready" => $pause, 'p' => $this->session->pause_request, "pauseName" => $pauseName));
	}

	public function selectCampaignQueue()
	{
		$extension = $this->session->userdata('extension');
		$campaign_queues = $this->input->post('campaign_queues');
		$campaign = $this->session->userdata('campaign');
		$agent_id = $this->session->userdata('user_userid');
		if ($campaign) {
			if ($campaign_queues) {
				$this->db->where('number', $extension);
				$this->db->delete('queue_numbers');
				foreach ($campaign_queues as $campaign_queue) {
					$queue_details = $this->agent_model->get_queue_id($campaign_queue);
					$data = array();
					$data = array(
						'queue_id' => $queue_details['id'],
						'number' => $extension,
						'status' => 0,
						'agent_id' => $agent_id,
					);
					$this->db->insert('queue_numbers', $data);
				}
			} else {
				$this->db->where('number', $extension);
				$this->db->delete('queue_numbers');
			}
			$tmp = array();
			$tmp = array(
				"campaign_id" => $campaign,
				"agent" => $agent_id,
				"extension" => $extension,
				"selected_queue" => isset($campaign_queues) ? implode(",", $campaign_queues) : null,
				"ip" => $this->input->ip_address(),
				"created_by" => $this->session->userdata('user_id')
			);
			$this->db->insert("agent_queue_select", $tmp);
		}
		echo json_encode(array("queue_selected" => "OK"));
	}

	public function getHangup()
	{
		$extension = $this->session->userdata('extension');
		$campaign = $this->session->userdata('campaign');
		$dispositionForm = '';
		if ($campaign) {
			$this->hangupagentcallfile();
			$hangupCalls = $this->agent_model->getHangupCall($extension);
			if ($hangupCalls) {
				$dispositionForm = $this->getDispositionForm($hangupCalls['uniqid']);
			}
		}
		echo json_encode(array("agent_hangup" => "OK", "uid" => $hangupCalls['uniqid'], "disposForm" => $dispositionForm, "dispo_timeout" => $this->data['callcenter_settings']['dispo_timeout']));
	}

	public function pushActiveAgentStatus()
	{
		$noticeHtml = "";
		$noticeId = "";
		$unreadCount = 0;
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$agent_status_raw = $this->agent_model->agent_status_push();
		$agent_status = $agent_status_raw['status'];
		$campaign = $this->session->userdata('campaign');
		$active_agent_view = '';
		if ($campaign) {
			$agentStateInterval = $this->calculate_interval($agent_status_raw['last_updated_at']);
			$agent_login_id = $this->session->userdata('agent_login_id');
			$this->data['activeAgentList'] = $this->agent_model->get_active_agent_list_push();
			$this->data['controller'] = $this;
			$active_agent_view .= $this->load->view('active_agent', $this->data, TRUE);

			//start get agent last status
			$this->db->select('id,status_date_time');
			$this->db->where('campaign', $campaign);
			$this->db->where('agent_id', $agent_id);
			$this->db->where('agent_sip', $extension);
			$this->db->where('agent_login_id', $agent_login_id);
			$this->db->order_by('id', 'DESC');
			$this->db->limit(1);
			$agent_status_last = $this->db->get('queue_agent_status')->row();
			//calculate duration start
			$agent_status_last_interval = $this->calculate_interval($agent_status_last->status_date_time);
			//calculate duration end
			//update log status start
			$agent_status_last_xyz = array();
			$agent_status_last_xyz = array(
				'last_response_time' => date('Y-m-d H:i:s'),
				'duration' => $agent_status_last_interval
			);
			$this->db->where('id', $agent_status_last->id);
			$this->db->update('queue_agent_status', $agent_status_last_xyz);
			//end get agent last status
			//update log status start

			$this->db->set('duration', "TIMESTAMPDIFF(SECOND, status_date_time, NOW())", false);
			$this->db->set('last_response_time', "NOW()", false);
			$this->db->where('agent_status', 'LOGGEDIN');
			$this->db->where('agent_login_id', $agent_login_id);
			$this->db->update('queue_agent_status');
			$this->db->set('duration_sec', "TIMESTAMPDIFF(SECOND, login_time, NOW())", false);
			$this->db->set('last_response_time', "NOW()", false);
			$this->db->where('id', $agent_login_id);
			$this->db->update('campaign_agent_login');
			//update log status end
			if ($this->data['callcenter_settings']['noticeboard'] == 1) {
				$noticeCheck = $this->agent_model->agent_notice_check();
				if ($noticeCheck == 0) {
					$notice = $this->agent_model->agent_notice();
					if ($notice) {
						$noticeHtml = $notice['message'];
						$noticeId = $notice['id'];
					}
				}
			}
			$unreadCount = getUnreadMessageCountAgent();
			echo json_encode(array("unreadCount" => $unreadCount, "noticeId" => $noticeId, "noticeHtml" => $noticeHtml, "agentStateInterval" => secondsToHMS($agentStateInterval), "live_agent_queue_array" => count($this->live_agent_queue_array), "agent_status" => $agent_status, "Push" => 'SUCCESS', "active_agent_view" => $active_agent_view));
		}
	}

	public function insert_notice_notify()
	{
		$id = $this->input->post('id');
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$data = array(
			'notice_id' => $id,
			'agent_id' => $agent_id,
			'agent_extension' => $extension,
			'ip' => $this->input->ip_address()
		);
		$this->db->insert('notice_agent', $data);
		echo json_encode(array("data" => "OK"));
	}

	public function checkLoggedIn()
	{
		$check_loggedin = $this->ion_auth->logged_in();
		echo $check_loggedin;
	}

	public function calculate_interval($time = '')
	{
		$interval = 0;
		if (!empty($time)) {
			$p_time1 = new DateTime($time);
			$p_time2 = new DateTime(date('Y-m-d H:i:s'));
			$interval = $p_time2->getTimestamp() - $p_time1->getTimestamp();
		}
		return $interval;
	}

	public function calculate_billsec_interval($time1 = '', $time2 = '')
	{
		$interval = 0;
		if (!empty($time1) && !empty($time2)) {
			$p_time1 = new DateTime($time1);
			$p_time2 = new DateTime($time2);
			$interval = $p_time2->getTimestamp() - $p_time1->getTimestamp();
		}
		return $interval;
	}

	protected function hangupagentcallfile()
	{
		$ext = $this->session->userdata('extension');
		$getAgentHangCall = $this->agent_model->getAgentHangCall();
		if (!empty($ext)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo "$errstr ($errno)\n";
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				//fputs($socket, "Action: Command\r\n");
				/*if ($getAgentHangCall['call_type'] === "IN") {
					fputs($socket, "Command: confbridge kick " . $ext . " participants\r\n");
				} elseif ($getAgentHangCall['call_type'] === "OUT") {
					fputs($socket, "Command: hangup request " . $getAgentHangCall['channel'] . "\r\n");
				}*/
				//fputs($socket, "Command: hangup request " . $getAgentHangCall['channel'] . "\r\n");
				// fputs($socket, "Action: Hangup\r\n");
				//  fputs($socket,  "Channel: SIP/9610537596-00000014\r\n");

				fputs($socket, "Action: Hangup\r\nChannel:" . $getAgentHangCall['channel'] . "\r\nCause: 116\r\n\r\n");


				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
				//echo $wrets;
			}
			/*else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Command\r\n");

				fputs($socket, "Command: hangup request " . $getAgentHangCall['channel'] . "\r\n");
				fputs($socket, "Variable:kickby=azad\r\n");
				//fputs($socket,  "Value:azad\r\n" );
				fputs($socket, "ActionID:1234\r\n");

				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
				//echo $wrets;
			}*/

			sleep(2);
			fclose($socket);
		}
	}

	protected function exitagentcallfile()
	{
		$ext = $this->session->userdata('extension');
		if (!empty($ext)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo "$errstr ($errno)\n";
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Command\r\n");
				fputs($socket, "Command: confbridge kick " . $ext . " all\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");
				$wrets = fgets($socket, 128);
			}

			sleep(2);
			fclose($socket);
		}
		$this->agent_model->closeLiveAgentStatus();
	}

	public function transfercall()
	{
		$transfer_number = $this->input->post('dial_number');
		$extension = $this->session->userdata('extension');
		$agent_status = $this->agent_model->agent_status();
		$activeCall = $this->agent_model->getActiveCall($extension, $agent_status['calling_status']);

		if (!empty($transfer_number)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo json_encode(array("transfer" => "ERROR"));
			} else {
				$this->agent_model->update_agent_calling_status();
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Redirect\r\n");
				fputs($socket, "Channel:" . $activeCall['channel'] . "\r\n");
				fputs($socket, "MaxRetries: 0\r\n");
				fputs($socket, "RetryTime: 0\r\n");
				fputs($socket, "Context: calltransfer\r\n");
				fputs($socket, "Priority: 1\r\n");
				fputs($socket, "Exten: $transfer_number\r\n");
				fputs($socket, "Callerid: $transfer_number\r\n");
				fputs($socket, "Variable:bridge=1003\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");
				echo json_encode(array("transfer" => "OK", "res" => $activeCall));
			}
			sleep(2);
			fclose($socket);
		}
	}

	public function holdUnhold()
	{
		$context = "";
		$hold = $this->input->post('hold');
		$extension = $this->session->userdata('extension');
		$agent_status = $this->agent_model->agent_status();
		$activeCall = $this->agent_model->getActiveCall($extension, $agent_status['calling_status']);
		if ($hold == 'hold') {
			$context = "callparking";
		} elseif ($hold == 'unhold') {
			$context = "call_recived";
		}
		if ($activeCall) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo "$errstr ($errno)\n";
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Redirect\r\n");
				fputs($socket, "Channel: " . $activeCall['channel'] . "\r\n");
				fputs($socket, "MaxRetries: 0\r\n");
				fputs($socket, "RetryTime: 0\r\n");
				fputs($socket, "Context: " . $context . "\r\n");
				fputs($socket, "Priority: 1\r\n");
				fputs($socket, "Exten: " . $extension . "\r\n");
				fputs($socket, "Callerid: " . $extension . "\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
				sleep(2);
				fclose($socket);
				echo json_encode(array("hold_unhold" => "OK", "channel" => $activeCall['channel'], "context" => $context, "hold" => $hold));
			}
		}
	}

	public function muteUnmute()
	{
		$context = "";
		$mute = $this->input->post('mute');
		$extension = $this->session->userdata('extension');

		$agent_status = $this->agent_model->agent_status();
		$activeCall = $this->agent_model->getActiveCall($extension, $agent_status['calling_status']);
		//set extension channel start
		$this->load->library('Asm_manager');
		$asm = new AGI_AsteriskManager();
		if ($asm->connect()) {
			$result = $asm->Command('confbridge list "' . $extension . '"');
			$raw = explode("\n", $result['data']);
			$rawData = explode(" ", $raw[3]);
			$extChannel = $rawData[0];
		}
		//set extension channel stop
		if ($mute == 'mute') {
			$action = "ConfbridgeMute";
		} elseif ($mute == 'unmute') {
			$action = "ConfbridgeUnmute";
		}
		if ($activeCall) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo "$errstr ($errno)\n";
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: " . $action . "\r\n");
				fputs($socket, "Conference: " . $extension . "\r\n");
				fputs($socket, "Channel: " . $extChannel . "\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
				sleep(2);
				fclose($socket);
				echo json_encode(array("mute_unmute" => "OK", "action" => $action, "mute" => $mute));
			}
		}
	}

	/*public function holdUnhold()
	{
		$context = "";
		$hold = $this->input->post('hold');
		$extension = $this->session->userdata('extension');
		$agent_status = $this->agent_model->agent_status();
		$activeCall = $this->agent_model->getActiveCall($extension, $agent_status['calling_status']);
		if ($hold == 'hold') {
			$context = "callparking";
		} elseif ($hold == 'unhold') {
			$context = "call_recived";
		}
		if ($activeCall) {
			if ($activeCall['call_type'] == "IN") {
				$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
				if (!$socket) {
					echo "$errstr ($errno)\n";
				} else {
					fputs($socket, "Action: Login\r\n");
					fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
					fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
					fputs($socket, "Action: Redirect\r\n");
					fputs($socket, "Channel: " . $activeCall['channel'] . "\r\n");
					fputs($socket, "MaxRetries: 0\r\n");
					fputs($socket, "RetryTime: 0\r\n");
					fputs($socket, "Context: " . $context . "\r\n");
					fputs($socket, "Priority: 1\r\n");
					fputs($socket, "Exten: " . $extension . "\r\n");
					fputs($socket, "Callerid: " . $extension . "\r\n");
					fputs($socket, "Action: Logoff\r\n\r\n");

					$wrets = fgets($socket, 128);
					sleep(2);
					fclose($socket);
					echo json_encode(array("hold_unhold" => "OK", "channel" => $activeCall['channel'], "context" => $context, "hold" => $hold));
				}
			} elseif ($activeCall['call_type'] == "OUT") {
				$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
				if (!$socket) {
					echo "$errstr ($errno)\n";
				} else {
					fputs($socket, "Action: Login\r\n");
					fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
					fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
					fputs($socket, "Action: Redirect\r\n");
					fputs($socket, "Channel: " . $activeCall['channel'] . "\r\n");
					fputs($socket, "MaxRetries: 0\r\n");
					fputs($socket, "RetryTime: 0\r\n");
					fputs($socket, "Context: " . $context . "\r\n");
					fputs($socket, "Priority: 1\r\n");
					fputs($socket, "Exten: " . $extension . "\r\n");
					fputs($socket, "Callerid: " . $extension . "\r\n");
					fputs($socket, "Action: Logoff\r\n\r\n");

					$wrets = fgets($socket, 128);
					sleep(2);
					fclose($socket);
					echo json_encode(array("hold_unhold" => "OK", "channel" => $activeCall['channel'], "context" => $context, "hold" => $hold));
				}
			}
		}
	}*/

	public function seek_help()
	{
		$transfer_number = $this->input->post('dial_number');
		$extension = $this->session->userdata('extension');
		$activeCall = $this->agent_model->getActiveCall($extension);

		if (!empty($transfer_number)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo json_encode(array("transfer" => "ERROR"));
			} else {
				echo json_encode(array("seekHelp" => "OK"));
			}
			sleep(2);
			fclose($socket);
		}
	}

	public function received_call()
	{
		$uid = $this->input->post('uid');
		$extension = $this->session->userdata('extension');
		$activeCall = $this->agent_model->getQueueCallSingle($uid);
		$agent_id = $this->session->userdata('user_userid');
		$agent_name = $this->session->userdata('name');
		$campaign = $this->session->userdata('campaign');
		$agent_login_id = $this->session->userdata('agent_login_id');

		if (!empty($activeCall)) {
			$this->agent_model->queueNumberStatusChange($activeCall['queue_id']);
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
				echo "$errstr ($errno)\n";
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName: " . MANAGER_USER . "\r\n");
				fputs($socket, "Secret: " . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Redirect\r\n");
				fputs($socket, "Channel:" . $activeCall['channel'] . "\r\n");
				fputs($socket, "MaxRetries: 0\r\n");
				fputs($socket, "RetryTime: 0\r\n");
				fputs($socket, "Context: call_recived_from_queue\r\n");
				fputs($socket, "Priority: 1\r\n");
				fputs($socket, "Exten: $extension\r\n");
				fputs($socket, "Variable:bridge=1003\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");
				$data = array(
					'attend_date' => date('Y-m-d'),
					'agent_id' => $agent_id,
					'agent_name' => $agent_name,
					'agent_status' => 'READY',
					'agent_sip' => $extension,
					'campaign' => $campaign,
					'last_response_time' => date('Y-m-d H:i:s'),
					'agent_login_id' => isset($agent_login_id) ? $agent_login_id : null,
					'ip' => $this->input->ip_address()
				);
				$this->db->insert('queue_agent_status', $data);
			}
			sleep(2);
			fclose($socket);
			$switch = $this->agent_model->switch_agent_status("READY");
			echo json_encode(array("received_call" => "OK"));
		} else {
			echo json_encode(array("received_call" => "NO"));
		}
	}

	public function call_back()
	{
		$queue_id = '';
		$uid = $this->input->post('uid');
		$clid = $this->input->post('clid');
		$extension = $this->session->userdata('extension');
		$callLog = $this->agent_model->current_call_log($uid);
		$dialNumber = $callLog->clid;
		$agentId = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');
		$campaignName = campaignNameFromID($campaign);
		$agent_id = $this->session->userdata('user_userid');
		//$out_routing = $this->session->userdata('out_route_name');

		$or = '';
		$queue_name = '';
		$selected_campaign_queues = $this->agent_model->selected_campaign_queues_lead($extension);
		if ($selected_campaign_queues) {
			$this->data['outbound_route_array'] = getRecordArray('outbound_route', 'id', 'title');
			$queue_id = $selected_campaign_queues['queue_id'];
			$queue_details = $this->agent_model->get_queue_details($selected_campaign_queues['queue_id']);
			$or = isset($this->data['outbound_route_array'][$queue_details['outbound_id']]) ? $this->data['outbound_route_array'][$queue_details['outbound_id']] : '';
			$queue_name = $queue_details['name'];
			if ($queue_id) {
				$queue_template_details = $this->agent_model->get_queue_template_details($queue_details['queue_template']);
			}
		}
		if ($or) {
			$out_routing = $or;
		} else {
			$out_routing = $this->session->userdata('out_route_name');
		}

		if (($callLog)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName:" . MANAGER_USER . "\r\n");
				fputs($socket, "Secret:" . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Originate\r\n");
				fputs($socket, "Channel: local/" . $extension . "@agent\r\n");
				fputs($socket, "Variable:trunknamenew=$out_routing\r\n");
				fputs($socket, "Context: phones\r\n");
				fputs($socket, "Exten: $dialNumber\r\n");
				fputs($socket, "Priority: 1\r\n");
				fputs($socket, "Callerid: $extension\r\n");
				fputs($socket, "Variable:A_PARTY=$dialNumber\r\n");
				fputs($socket, "Variable:agent=$extension\r\n");
				fputs($socket, "Variable:call_strategy=1\r\n");
				fputs($socket, "Variable:recording=0\r\n");
				fputs($socket, "Variable:caller_point_agent=0\r\n");
				fputs($socket, "Variable:campaign_id=" . $campaign . "\r\n");
				fputs($socket, "Variable:campaign_name=" . $campaignName . "\r\n");
				fputs($socket, "Variable:agent_id=" . $agentId . "\r\n");
				fputs($socket, "Variable:agent_name=" . $agent_id . "\r\n");
				fputs($socket, "Variable:queue_template=" . $queue_details['queue_template'] . "\r\n");
				fputs($socket, "Variable:musiconhold=" . $queue_template_details['musiconhold'] . "\r\n");
				fputs($socket, "Async: yes\r\n\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
				$scheduleData = array();
				$scheduleData['call_back'] = 1;
				$scheduleData['call_back_time'] = date('Y-m-d H:i:s');

				//$this->db->where('uniqueid', $uid);
				$this->db->where('direction', 'IN');
				$this->db->where('clid', $clid);
				$this->db->where('status', 'failed');
				$this->db->where('call_back', 0);
				$this->db->where('call_back_time IS NULL');
				$this->db->update('queue_cdr', $scheduleData);
			}
			sleep(2);
			fclose($socket);
			$switch = $this->agent_model->switch_agent_status("PAUSE");
			echo json_encode(array("call_back" => "OK"));
		}
	}

	public function schedule_call()
	{
		$uid = $this->input->post('uid');
		$extension = $this->session->userdata('extension');
		$callLog = $this->agent_model->current_call_log($uid);
		$dialNumber = $callLog->clid;
		$agentId = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');
		$campaignName = campaignNameFromID($campaign);
		$out_routing = $this->session->userdata('out_route_name');

		if (($callLog)) {
			$socket = fsockopen(MANAGER_HOST, MANAGER_PORT, $errno, $errstr, 10);
			if (!$socket) {
			} else {
				fputs($socket, "Action: Login\r\n");
				fputs($socket, "UserName:" . MANAGER_USER . "\r\n");
				fputs($socket, "Secret:" . MANAGER_PWD . "\r\n\r\n");
				fputs($socket, "Action: Originate\r\n");
				fputs($socket, "Channel: local/" . $dialNumber . "@phones\r\n");
				fputs($socket, "Variable:trunknamenew=$out_routing\r\n");
				fputs($socket, "Context: agent_outbound\r\n");
				fputs($socket, "Exten: $extension\r\n");
				fputs($socket, "Priority: 1\r\n");
				fputs($socket, "Callerid: $extension\r\n");
				fputs($socket, "Variable:A_PARTY=$dialNumber\r\n");
				fputs($socket, "Variable:agent=$extension\r\n");
				fputs($socket, "Variable:call_strategy=1\r\n");
				fputs($socket, "Variable:recording=0\r\n");
				fputs($socket, "Variable:caller_point_agent=0\r\n");
				fputs($socket, "Variable:campaign_id=" . $campaign . "\r\n");
				fputs($socket, "Variable:campaign_name=" . $campaignName . "\r\n");
				fputs($socket, "Variable:agent_id=" . $agentId . "\r\n");
				fputs($socket, "Async: yes\r\n\r\n");
				fputs($socket, "Action: Logoff\r\n\r\n");

				$wrets = fgets($socket, 128);
				$scheduleData = array();
				$scheduleData['call_back'] = 1;
				$scheduleData['call_back_time'] = date('Y-m-d H:i:s');

				$this->db->where('uniqueid', $uid);
				$this->db->update('queue_cdr', $scheduleData);
			}
			sleep(2);
			fclose($socket);
			$switch = $this->agent_model->switch_agent_status("PAUSE");
			echo json_encode(array("schedule_call" => "OK"));
		}
	}

	function generateCode($limit)
	{
		$code = '';
		for ($i = 0; $i < $limit; $i++) {
			$code .= mt_rand(0, 9);
		}
		return $code;
	}

	public function btcl_api($mobiles = "", $rawMessage = "")
	{
		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));
		//$mobiles = "01777770287, 01719193618,";
		$rawMobils = explode(",", $mobiles);
		if (count($rawMobils)) {
			$finalMobiles = "";
			$i = 0;
			foreach ($rawMobils as $value) {
				if (!empty($value)) {
					$value = "88" . trim($value);
					if ($i > 0) {
						$finalMobiles .= "|" . $value;
					} else {
						$finalMobiles .= $value;
					}
					$i = 1;
				}
			}
		}
		//echo $finalMobiles;
		//exit;
		$p = $this->generateCode(16);
		$tmp = (int)$p + 90;
		$a = MD5($tmp . '****');
		/* API URL */
		$url = 'http://bulksms1.teletalk.com.bd:8091/jlinktbls.php';

		/* Init cURL resource */
		$ch = curl_init($url);

		/* Array Parameter Data */
		$data = array(
			"op" => "SMS",
			"chunk" => "G",
			"user" => "callcenter.btcl",
			"pass" => "7418fcd03a4cc4a8d6935b09df028b27",
			"servername" => "bulksms1.teletalk.com.bd",
			"smsclass" => "GENERAL",
			"sms" => $message,
			"sms_id" => "",
			"mobile" => "$finalMobiles",
			"charset" => "ASCII",
			"validity" => "1440",
			"a_key" => $a,
			"p_key" => $p,
			"cid" => "1234567890"
		);

		$body = json_encode($data);

		$ch = curl_init($url);

		curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		/* execute request */
		$result = curl_exec($ch);
		$result = json_decode($result, true);
		//echo "<pre>";
		//print_r(json_decode($result, true));
		/* close cURL resource */
		curl_close($ch);
		return $result;
	}

	public function jk_sms_api($mobiles = "", $rawMessage = "")
	{
		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));
		//$mobiles = "01777770287, 01719193618,";
		$rawMobils = explode(",", $mobiles);
		if (count($rawMobils)) {
			$finalMobiles = "";
			$i = 0;
			foreach ($rawMobils as $value) {
				if (!empty($value)) {
					$value = "88" . trim($value);
					if ($i > 0) {
						$finalMobiles .= "," . $value;
					} else {
						$finalMobiles .= $value;
					}
					$i = 1;
				}
			}
		}
		//echo $finalMobiles;
		//exit;
		/* API URL */
		$url = 'http://bulksmsbd.net/api/smsapi';
		$api_key = "YjbloK0KZA6aZNClOzhh";
		$senderid = "JKLIFESTYLE";

		/* Init cURL resource */
		$ch = curl_init($url);

		/* Array Parameter Data */
		$data = array(
			"api_key" => $api_key,
			"senderid" => $senderid,
			"number" => $finalMobiles,
			"message" => $message,
		);

		$body = json_encode($data);

		$ch = curl_init($url);

		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

		/* execute request */
		$result = curl_exec($ch);
		$result = json_decode($result, true);
		//echo "<pre>";
		//print_r(json_decode($result, true));
		/* close cURL resource */
		curl_close($ch);
		return $result;
	}

	public function sibl_sms_api($mobile = "", $rawMessage = "")
	{
		$message = strip_tags(trim(preg_replace('/\s+/', ' ', $rawMessage)));

		$url = "https://smsgw.sjiblbd.com/sms-api/api/auth/single-sms"; // Replace with actual API URL

// Sample data
		$data = array(
			"msisdn" => $mobile,
			"message" => $message
		);

// Convert data to JSON
		$jsonData = json_encode($data);

// Headers
		$headers = array(
			"Content-Type: application/json",
			"UserId: YourUserID",        // Replace with actual User ID
			"SecretKey: YourSecretKey",  // Replace with actual Secret Key
			"Authorization: YourAuthKey" // Replace with actual Authorization Key
		);

// Initialize cURL
		$ch = curl_init($url);

// Set cURL options
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

// Execute the request
		$response = curl_exec($ch);

// Check for cURL errors
		if (curl_errno($ch)) {
			echo "cURL Error: " . curl_error($ch);
		}

// Close cURL session
		curl_close($ch);

// Output response
		return $response;
	}
}
