<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class Agent_model extends CI_Model
{

	public function __construct()
	{
		// Call the CI_Model constructor
		parent::__construct();
	}

	public function getNextAgent()
	{
		// Get the last assigned agent ID
		$lastAssignedAgentId = $this->getLastAssignedAgentId();

		// Get the next agent in a round-robin fashion
		$this->db->order_by('id', 'ASC');
		$this->db->where('id >', $lastAssignedAgentId);
		$this->db->where('status', 'READY');
		$this->db->where('calling_status IS NULL');
		$query = $this->db->get('tmp_agent_status');

		if ($query->num_rows() > 0) {
			$nextAgent = $query->row();
		} else {
			// If no agent is found, start from the beginning
			$this->db->where('status', 'READY');
			$this->db->where('calling_status IS NULL');
			$this->db->order_by('id', 'ASC');
			$query = $this->db->get('tmp_agent_status');
			$nextAgent = $query->row();
		}

		// Update the last assigned agent ID
		if ($nextAgent) {
			$this->updateLastAssignedAgentId($nextAgent->id);
		}

		return $nextAgent;
	}

	private function getLastAssignedAgentId()
	{
		$this->db->where('key_name', 'last_assigned_agent_id');
		$query = $this->db->get('email_rr_settings');
		$row = $query->row();
		return $row ? (int)$row->value : 0;
	}

	private function updateLastAssignedAgentId($id)
	{
		$this->db->where('key_name', 'last_assigned_agent_id');
		$this->db->update('email_rr_settings', array('value' => $id));
	}

	function mail_unread_last()
	{
		$this->db->where('email_read', 0);
		$this->db->where('email_type', 'INBOX');
		$query = $this->db->get('adn_email');
		return $query->row_array();
	}

	/*function getUserChat($from_user_id, $to_user_id)
	{
		$fromUserAvatar = $this->getUserAvatar($from_user_id);
		$toUserAvatar = $this->getUserAvatar($to_user_id);
		$sql = $this->db->query("SELECT * FROM chat WHERE (sender_userid = '" . $from_user_id . "' AND reciever_userid = '" . $to_user_id . "') OR (sender_userid = '" . $to_user_id . "' AND reciever_userid = '" . $from_user_id . "') ORDER BY timestamp ASC");
		$userChat = $sql->result_array();
		$conversation = '<ul>';
		foreach ($userChat as $chat) {
			$user_name = '';
			if ($chat["sender_userid"] == $from_user_id) {
				$conversation .= '<li class="sent">';
				$conversation .= '<img width="22px" height="22px" src="' . $fromUserAvatar . '" alt="" />';
			} else {
				$conversation .= '<li class="replies">';
				$conversation .= '<img width="22px" height="22px" src="' . $toUserAvatar . '" alt="" />';
			}
			$conversation .= '<p>' . $chat["message"] . '</p>';
			$conversation .= '</li>';
		}
		$conversation .= '</ul>';
		return $conversation;
	}

	function getUserAvatar($userid)
	{
		$this->db->select('photo');
		$this->db->where('id', $userid);
		$sql = $this->db->get('users');
		$result = $sql->row();
		$userPhoto = '';
		if (!empty($result->photo)) {
			$userPhoto = base_url() . "media/userphotos/" . $result->photo;
		} else {
			$userPhoto = base_url() . "media/userphotos/user.jpg";
		}
		return $userPhoto;
	}

	function get_chat_users()
	{
		$this->db->where('id !=', $this->session->userdata('user_id'));
		$this->db->where('userid IS NOT NULL', NULL, FALSE);
		$query = $this->db->get('users');
		$result = $query->result_array();
		return $result;
	}

	function get_logged_user_details()
	{
		$this->db->where('id', $this->session->userdata('user_id'));
		$query = $this->db->get('users');
		$result = $query->row_array();
		return $result;
	}*/

	function getAllLiveCall()
	{
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->result_array();
		return $result;
	}

	function getAllLiveCallv2()
	{
		$this->db->group_start();
		$this->db->where('call_type', 'IN');
		$this->db->where_in('status', array('1', '0'));
		$this->db->group_end();
		$this->db->or_group_start();
		$this->db->where('call_type', 'OUT');
		$this->db->where_in('status', array('3', '4', '0'));
		$this->db->group_end();
		$this->db->order_by('call_connect_time', 'DESC');
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->result_array();
		return $result;
	}

	function switch_agent_status($status = null)
	{
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$agent_name = $this->session->userdata('name');
		$campaign = $this->session->userdata('campaign');
		//exist agent info
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$checkData = $this->db->get('tmp_agent_status');
		if ($checkData->num_rows() == 1) {
			$currentData = $checkData->row_array();
			$aid = $currentData['id'];
			$this->db->where('id', $aid);
			$this->db->update('tmp_agent_status', array(
				"extension" => $extension,
				"agent_id" => $agent_id,
				"agent_name" => $agent_name,
				"campaign" => $campaign,
				"status" => $status,
				"ip" => $this->input->ip_address(),
				"last_updated_at" => date('Y-m-d H:i:s')
			));
		}
	}

	function update_agent_calling_status($status = null, $call_time = null)
	{
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');

		//exist agent info
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$checkData = $this->db->get('tmp_agent_status');
		if ($checkData->num_rows() == 1) {
			$currentData = $checkData->row_array();
			$aid = $currentData['id'];
			$this->db->where('id', $aid);
			$this->db->update('tmp_agent_status', array(
				"calling_status" => $status,
				"call_time" => $call_time,
				"ip" => $this->input->ip_address(),
				"last_updated_at" => date('Y-m-d H:i:s')
			));
		}
	}

	function getAgentHangCall($uid = '')
	{
		$extension = $this->session->userdata('extension');
		if ($uid) {
			$this->db->where('uniqid', $uid);
		}
		$this->db->where('agent', $extension);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getAgentInboundCall()
	{
		$extension = $this->session->userdata('extension');
		//$this->db->where('status', 1);
		$this->db->where('call_type', 'IN');
		$this->db->where('agent', $extension);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getInboundCallList($agentSelectedQueue = array())
	{
		if (count($agentSelectedQueue)) {
			$this->db->where('status', 2);
			$this->db->where('call_type', 'IN');
			$this->db->where_in('queue_id', $agentSelectedQueue);
			$query = $this->db->get('queue_cdr_tmp');
			$result = $query->result_array();
			return $result;
		} else {
			return false;
		}
	}

	function getOutboundAgentCall()
	{
		$extension = $this->session->userdata('extension');
		//$this->db->where('status', 3);
		$this->db->where('agent', $extension);
		$this->db->where('call_type', 'OUT');
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getAgentInHangupCall()
	{
		$extension = $this->session->userdata('extension');
		$this->db->where('status', 0);
		$this->db->where('agent', $extension);
		$this->db->where('call_type', 'IN');
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	/*function getAgentOutHangupCall()
	{
		$extension = $this->session->userdata('extension');
		$this->db->where('status', 0);
		$this->db->where('agent', $extension);
		$this->db->where('call_type', 'OUT');
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}*/


	function live_agent_queue()
	{
		$extension = $this->session->userdata('extension');
		$this->db->select('queue_id');
		$this->db->where('number', $extension);
		//$this->db->where('agent_status', 'inbound');
		$query = $this->db->get('queue_numbers');
		$result = $query->result();
		$resultArray = array();
		if ($query->num_rows() > 0) {
			foreach ($result as $d) {
				$resultArray[] = $d->queue_id;
			}
		}
		return $resultArray;
	}

	function agent_status()
	{
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$query = $this->db->get('tmp_agent_status');
		$result = $query->row_array();
		return $result;
	}

	function agent_status_push()
	{
		$this->db->select('status, last_updated_at');
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$query = $this->db->get('tmp_agent_status');
		$result = $query->row_array();
		return $result;
	}

	function agent_status_for_live()
	{
		$this->db->select('id,status,calling_status');
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$query = $this->db->get('tmp_agent_status');
		$result = $query->row_array();
		return $result;
	}

	/*function outbound_call_log()
	{
		$agent_id = $this->session->userdata('user_userid');
		$this->db->where('agent', $agent_id);
		$this->db->order_by('created_on', 'DESC');
		$this->db->limit(10);
		$query = $this->db->get('outbound_call_log');
		$result = $query->result();
		return $result;
	}*/
	function outbound_call_log()
	{
		$agent_id = $this->session->userdata('user_userid');
		$this->db->where('agent_id', $agent_id);
		$this->db->where('direction', 'OUT');
		$this->db->order_by('call_date', 'DESC');
		$this->db->limit(10);
		$query = $this->db->get('queue_cdr');
		$result = $query->result();
		return $result;
	}

	function next_contact()
	{
		$campaign = $this->session->userdata('campaign');
		$this->db->where('status', 0);
		$this->db->where('campaign_id', $campaign);
		$this->db->limit(1);
		$query = $this->db->get('lead_contacts');
		$result = $query->row_array();
		if ($query->num_rows() > 0) {
			//return $result['contact_no'];
			return $result;
		} else {
			return null;
		}
	}

	function getCrm($src = '')
	{
		if (!empty($src)) {
			$this->db->where('phone', $src);
			$query = $this->db->get('clients');
			$result = $query->row();
			return $result;
		}
	}

	function getClientNote($uid = '')
	{
		if (!empty($uid)) {
			$this->db->where('uid', $uid);
			$query = $this->db->get('client_notes');
			$result = $query->row();
			return $result;
		}
	}

	function getCrmClientDetails($src = '')
	{
		if (!empty($src)) {
			$this->db->select(
				'crm_contact.name,crm_contact.email,crm_contact.phone,crm_contact.contact_type,crm_contact.branch_id as contact_branch_id,
				crm_branch_list.branch_name as branch_name,crm_clients.name as client_name,crm_clients.id as client_id,
				crm_clients.ragistered_address,crm_clients.ragistered_thana,crm_clients.ragistered_district,
				crm_clients.ragistered_division,crm_clients.status,crm_clients_address.installation_address,
				crm_clients_address.installation_thana,crm_clients_address.installation_district,
				crm_clients_address.installation_division,crm_clients_address.billing_address,
				crm_clients_address.billing_thana,crm_clients_address.billing_district,
				crm_clients_address.billing_division,crm_clients.rm_id,crm_clients.client_type'
			);
			$this->db->from('crm_contact');
			$this->db->join('crm_branch_list', 'crm_contact.branch_id = crm_branch_list.id', 'left');
			$this->db->join('crm_clients', 'crm_contact.client_id = crm_clients.id', 'left');
			$this->db->join('crm_clients_address', 'crm_contact.branch_id = crm_clients_address.id', 'left');
			$this->db->like('crm_contact.phone', $src, 'before');
			$query = $this->db->get();
			$result = $query->result_array();
			return $result;
		}
	}

	function current_call_log($uid = '')
	{
		$this->db->where('uniqueid', $uid);
		$query = $this->db->get('queue_cdr');
		$result = $query->row();
		return $result;
	}

	function getActiveCall($extension = '', $calling_status = '')
	{
		if ($calling_status == 'OUTCALL') {
			$this->db->where('status', 3);
			$this->db->where('call_type', 'OUT');
		} else {
			$this->db->where('status', 1);
			$this->db->where('call_type', 'IN');
		}
		$this->db->where('agent', $extension);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getHangupCall($extension = '')
	{
		$extension = $this->session->userdata('extension');
		$this->db->where('status', 0);
		$this->db->where('agent', $extension);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getWaitCall($extension = '')
	{
		$this->db->where('status', 2);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getOutCall($extension = '')
	{
		$extension = $this->session->userdata('extension');
		//$this->db->where('agent', $extension);
		$this->db->where('status', 3);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getQueueCallSingle($uid = '')
	{
		$this->db->where('status', 2);
		$this->db->where('uniqid', $uid);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	/*function queueNumberStatusChange($queue_id = "")
	{
		$extension = $this->session->userdata('extension');
		$this->db->where('queue_id', $queue_id);
		$this->db->where('number', $extension);
		$this->db->update('queue_numbers', array("agent_status" => "inbound", "call_order_type" => 1, "status" => 1));
		if ($this->db->affected_rows()) {
			$this->db->where('number', $extension);
			$this->db->update('queue_numbers', array("agent_status" => "inbound"));
		}
		return $this->db->affected_rows();
	}*/

	function queueNumberStatusChange($queue_id = "")
	{
		$extension = $this->session->userdata('extension');
		$this->db->where('queue_id', $queue_id);
		$this->db->where('number', $extension);
		$this->db->update('queue_numbers', array("agent_status" => "inbound", "call_order_type" => 1, "status" => 1));
		return $this->db->affected_rows();
	}

	function getQueueCall()
	{
		$this->db->where('status', 2);
		$result = $this->db->count_all_results('queue_cdr_tmp');
		return $result;
	}

	function getTempCall($uid = '')
	{
		$this->db->where('status', 1);
		$this->db->where('uniqid', $uid);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}

	function getAltTempCall($uid = '')
	{
		//$this->db->where('call_type', 'IN');
		$this->db->where('status', 0);
		$this->db->where('uniqid', $uid);
		$query = $this->db->get('queue_cdr_tmp');
		$result = $query->row_array();
		return $result;
	}
	//	function checkAgentCall()
	//	{
	//		$extension = $this->session->userdata('extension');
	//		$this->db->where('agent', $extension);
	//		$query = $this->db->get('queue_cdr_tmp');
	//		$result = $query->row_array();
	//		return $result;
	//	}
	function check_queue_agent($ext = '', $queue_id = '')
	{
		$this->db->where('queue_id', $queue_id);
		$this->db->where('number', $ext);
		$this->db->where('agent_status', 'pause');
		$this->db->where('status', 1);
		$query = $this->db->get('queue_numbers');
		$resultObj = $query->num_rows();
		return $resultObj;
	}

	function get_queue_id($queue_name = '')
	{
		$this->db->where('name', $queue_name);
		$this->db->where('status', 1);
		$query = $this->db->get('queue');
		$resultObj = $query->row_array();
		return $resultObj;
	}

	function check_queue_number($ext = '', $agent_id = '', $queue_id = '')
	{
		$this->db->where('queue_id', $queue_id);
		$this->db->where('name', $agent_id);
		$this->db->where('number', $ext);
		$query = $this->db->get('queue_numbers');
		$numRows = $query->num_rows();
		return $numRows;
	}

	function queue_numbers($id = 0)
	{
		if ($id > 0)
			return $this->db->where('queue_id', $id)
				->where('agent_status', 'inbound')
				->get('queue_numbers')
				->result();
		else
			return NULL;
	}

	function all_queue_numbers()
	{
		return $this->db->where('agent_status', 'inbound')
			->get('queue_numbers')
			->result();
	}

	function all_queue_record()
	{
		$this->db->order_by('name', 'ASC');
		return $this->db->get('queue')->result();
	}

	function failed_call($startTime = '', $endTime = '')
	{
		$this->db->select('queue_cdr.ivr_seconds as ivr_seconds,queue_cdr.queue_seconds as queue_seconds,queue_cdr.queue_id as queue_id,queue_cdr.campaign_id as campaign_id,queue_cdr.end_call as end_call,queue_cdr.uniqueid as uniqueid,queue_cdr.clid as caller,queue_cdr.direction as direction,queue_cdr.call_date as call_date,queue_cdr.hunting_number as hunting_number, clients.name as name');
		$this->db->join('clients', 'clients.phone = queue_cdr.clid', 'left');
		$this->db->where('queue_cdr.status', 'failed');
		$this->db->where('queue_cdr.queue_seconds >', '0');
		$this->db->where('queue_cdr.call_back', 0);
		$this->db->where('queue_cdr.direction', 'IN');
		if (!empty($startTime) && !empty($endTime)) {
			$this->db->where("TIME(queue_cdr.call_date) BETWEEN '" . $startTime . "' AND '" . $endTime . "'");
		}
		$this->db->order_by('queue_cdr.id', 'DESC');
		//$this->db->group_by(array("queue_cdr.clid", "clients.name"));
		$query = $this->db->get('queue_cdr');
		$result = $query->result();
		return $result;
	}

	function schedule_call()
	{
		$directions = str_replace("'", "", explode(",", ALL_DIRECTION));
		$this->db->where('status', 'answer');
		$this->db->where_in('direction', $directions);
		$this->db->where('schedule_call', 1);
		$this->db->where('call_back', 0);
		$this->db->where("call_date BETWEEN '" . date('Y-m-d 00:00:00') . "' AND '" . date('Y-m-d 23:59:59') . "'");
		$this->db->order_by('schedule_call_time', 'DESC');
		$query = $this->db->get('queue_cdr');
		$result = $query->result();
		return $result;
	}

	function my_call()
	{
		$this->db->where('agent_id', $this->session->userdata('user_userid'));
		//$this->db->where('status', 'answer');
		$this->db->where("call_date BETWEEN '" . date('Y-m-d 00:00:00') . "' AND '" . date('Y-m-d 23:59:59') . "'");
		$this->db->order_by('id', 'DESC');
		$query = $this->db->get('queue_cdr');
		$result = $query->result();
		return $result;
	}

	function client_call_history($cid = '')
	{
		$this->db->select('client_notes.client_note as note,queue_cdr.call_status as call_status, queue_cdr.status as status,queue_cdr.hunting_number as hunting_number,queue_cdr.direction as direction,queue_cdr.hangup_by as hangup_by,SEC_TO_TIME(queue_cdr.billsec) as billsec,queue_cdr.call_date as time,queue_cdr.clid as caller, clients.name as name');
		$this->db->join('clients', 'clients.phone = queue_cdr.clid', 'left');
		$this->db->join('client_notes', 'client_notes.uid = queue_cdr.uniqueid', 'left');
		$this->db->where('clients.id', $cid);
		$this->db->where('queue_cdr.status', 'answer');
		//$this->db->where('queue_cdr.direction', 'IN');
		$this->db->where('queue_cdr.agent', $this->session->userdata('extension'));
		$this->db->where("call_date BETWEEN '" . date('Y-m-d 00:00:00') . "' AND '" . date('Y-m-d 23:59:59') . "'");
		$this->db->order_by('queue_cdr.id', 'DESC');
		$this->db->limit(10);
		$query = $this->db->get('queue_cdr');
		$result = $query->result();
		return $result;
	}

	function summary_search_cdr()
	{
		$query = $this->db->query("SELECT `agent`, SUM(IF(`direction`='IN', 1, 0)) as inbound, SUM(IF(`direction`='OUT', 1, 0)) as outbound, SUM(IF(`direction`='IN', `duration`, 0)) totalincalltime, SUM(IF(`direction`='OUT', `billsec`, 0)) totaloutcalltime FROM `queue_cdr` WHERE `call_status` = 'ANSWER' group by `agent`");
		return $query->result();
	}

	function summary_my_cdr()
	{
		$agent_id = $this->session->userdata('user_userid');
		$callDate = "'" . date('Y-m-d') . " 00:00:00' AND '" . date('Y-m-d') . " 23:59:59'";
		//$query = $this->db->query("SELECT `agent_id`, SUM(IF(`direction`='IN', 1, 0)) as inbound, SUM(IF(`direction`='OUT', 1, 0)) as outbound, SEC_TO_TIME(SUM(IF(`direction`='IN', `billsec`, 0))) totalincalltime, SEC_TO_TIME(SUM(IF(`direction`='OUT', `billsec`, 0))) totaloutcalltime, SUM(IF(`direction`='OUT', `billsec`, 0)) totaloutcalltimesec FROM `queue_cdr` WHERE `status` = 'answer' AND agent_id='" . $agent_id . "' AND (call_date BETWEEN " . $callDate . ")");
		$query = $this->db->query("SELECT `agent_id`, SUM(IF(`direction`='IN', 1, 0)) as inbound, SUM(IF(`direction`='OUT', 1, 0)) as outbound, SEC_TO_TIME(SUM(IF(`direction`='IN', `billsec`, 0))) totalincalltime, SEC_TO_TIME(SUM(IF(`direction`='OUT', `billsec`, 0))) totaloutcalltime, SUM(IF(`direction`='OUT', `billsec`, 0)) totaloutcalltimesec FROM `queue_cdr` WHERE agent_id='" . $agent_id . "' AND (call_date BETWEEN " . $callDate . ")");
		return $query->row_array();
	}

	function summary_my_others()
	{
		$agent_id = $this->session->userdata('user_userid');
		$callDate = "'" . date('Y-m-d') . " 00:00:00' AND '" . date('Y-m-d') . " 23:59:59'";
		$query = $this->db->query("SELECT `agent_id`,MAX(IF(`agent_status`='LOGGEDOUT', last_response_time, '')) AS 'logout',MIN(`status_date_time`) AS 'login',SEC_TO_TIME(SUM(IF(`agent_status`='LOGGEDIN', duration, 0))) AS 'login_duration',SEC_TO_TIME(SUM(IF(`agent_status`='READY', duration, 0))) AS 'ready_duration',SEC_TO_TIME(SUM(IF(`agent_status`='PAUSE', duration, 0))) AS 'pause_duration',SUM(IF(`agent_status` IN('INBOUND','OUTBOUND'), hold_duration, 0)) AS 'hold_duration_sec',SUM(IF(`agent_status` IN('INBOUND','OUTBOUND'), IF(`hold_duration`>0, 1, 0), 0)) AS 'total_hold_call',
								SUM(IF(`agent_status`='PAUSE', duration, 0)) AS 'pause_duration_sec',SUM(IF(`agent_status`='PAUSE', 1, 0)) AS 'pause_count',SEC_TO_TIME(SUM(IF(`agent_status`='DISPOSITION', duration, 0))) AS 'dispo_duration',SUM(IF(`agent_status`='DISPOSITION', duration, 0)) AS 'dispo_duration_sec',SUM(IF(`agent_status`='DISPOSITION', 1, 0)) AS 'dispo_count',SEC_TO_TIME(SUM(IF(`agent_status` IN('INBOUND','OUTBOUND'), duration, 0))) AS 'call_duration',SUM(IF(`agent_status`='INBOUND', duration, 0)) AS 'total_talktime_sec',SUM(IF(`agent_status`='INBOUND', hold_duration, 0)) AS 'total_inbound_hold_sec',SEC_TO_TIME(SUM(IF(`agent_status`='INBOUND', duration, 0))) AS 'inbound_duration',SEC_TO_TIME(SUM(IF(`agent_status`='OUTBOUND', duration, 0))) AS 'outbound_duration',SUM(IF(`agent_status` IN('INBOUND','OUTBOUND'), 1, 0)) AS 'total_call' FROM `queue_agent_status`
								 WHERE `agent_id` = '" . $agent_id . "' AND (attend_date BETWEEN " . $callDate . ")");
		return $query->row_array();
	}

	function check_client($client_phone)
	{
		$this->db->like('phone', $client_phone, 'before');
		//$this->db->where('phone', $client_phone);
		$query = $this->db->get('clients');
		$result = $query->row_array();
		return $result;
	}

	function failed_call_details($callerId = '')
	{
		if (!empty($callerId)) {
			$this->db->where('status', 'failed');
			$this->db->where('direction', 'IN');
			$this->db->where('clid', $callerId);
			$this->db->where("call_date BETWEEN '" . date('Y-m-d 00:00:00') . "' AND '" . date('Y-m-d 23:59:59') . "'");
			$query = $this->db->get('queue_cdr');
			$result = $query->result();
			return $result;
		}
	}

	function queue_number_total()
	{
		$this->db->select('COUNT(*) total,queue_id');
		$this->db->where('agent_status', 'inbound');
		$this->db->group_by('queue_id');
		$query = $this->db->get('queue_numbers');
		$result = $query->result();
		return $result;
	}

	function get_campaign_queue_array($campaign = '')
	{
		$resultObj = $this->db->select('campaign_id, queue_id')
			->where('campaign_id', $campaign)
			->get('campaign_queue')
			->result();

		$tmpResult = array();
		foreach ($resultObj as $row)
			$tmpResult[$row->queue_id] = $row->queue_id;

		return $tmpResult;
	}

	function selected_campaign_queues($extension = '')
	{
		$this->db->where('number', $extension);
		$query = $this->db->get('queue_numbers');
		$result = $query->result();
		return $result;
	}

	function selected_campaign_queues_lead($extension = '')
	{
		$this->db->where('number', $extension);
		$this->db->limit(1);
		$query = $this->db->get('queue_numbers');
		$result = $query->row_array();
		return $result;
	}

	function get_queue_details($queue_id = '')
	{
		$this->db->where('id', $queue_id);
		$this->db->where('status', 1);
		$query = $this->db->get('queue');
		$resultObj = $query->row_array();
		return $resultObj;
	}

	function change_agent_status($status = null, $pause_type_id = null, $calling_status = null, $call_time = null)
	{
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$agent_name = $this->session->userdata('name');
		$campaign = $this->session->userdata('campaign');
		//exist agent info
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$checkData = $this->db->get('tmp_agent_status');
		if ($checkData->num_rows() == 1) {
			$currentData = $checkData->row_array();
			$aid = $currentData['id'];
			$this->db->where('id', $aid);
			$this->db->update('tmp_agent_status', array(
				"extension" => $extension,
				"agent_id" => $agent_id,
				"agent_name" => $agent_name,
				"campaign" => $campaign,
				"status" => $status,
				"calling_status" => $calling_status,
				"call_time" => $call_time,
				"pause_type_id" => !is_null($pause_type_id) ? $pause_type_id : null,
				"ip" => $this->input->ip_address(),
				"last_updated_at" => date('Y-m-d H:i:s'),
				"browser" => $this->agent->browser() . '|' . $this->agent->version() . '|' . $this->agent->platform()
			));
		} else {
			$this->db->insert('tmp_agent_status', array(
				"extension" => $extension,
				"agent_id" => $agent_id,
				"agent_name" => $agent_name,
				"campaign" => $campaign,
				"status" => $status,
				"pause_type_id" => !is_null($pause_type_id) ? $pause_type_id : null,
				"ip" => $this->input->ip_address(),
				"browser" => $this->agent->browser() . '|' . $this->agent->version() . '|' . $this->agent->platform()
			));
		}
	}

	function get_active_agent_list()
	{
		$this->db->where('status is NOT NULL', NULL, FALSE);
		$this->db->order_by('extension', 'ASC');
		$query = $this->db->get('tmp_agent_status');
		$result = $query->result();
		return $result;
	}

	function get_active_agent_list_push()
	{
		$this->db->select('agent_id,extension,calling_status,call_time,status');
		$this->db->where('status is NOT NULL', NULL, FALSE);
		$this->db->order_by('extension', 'ASC');
		$query = $this->db->get('tmp_agent_status');
		$result = $query->result();
		return $result;
	}

	function change_queue_number_status($status = "")
	{
		$extension = $this->session->userdata('extension');
		$this->db->where('number', $extension);
		//$result = $this->db->update('queue_numbers', array("agent_status" => $status));
		$result = $this->db->update('queue_numbers', array("agent_status" => $status, "status" => 0));
		return $result;
	}

	function closeLiveAgentStatus($id = null)
	{
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');
		$campaign = $this->session->userdata('campaign');
		$this->db->where('extension', $extension);
		$this->db->where('agent_id', $agent_id);
		$this->db->where('campaign', $campaign);
		$this->db->update('tmp_agent_status', array("status" => null, "calling_status" => null, "call_time" => null));
	}

	function agent_notice_check()
	{
		$extension = $this->session->userdata('extension');
		$agent_id = $this->session->userdata('user_userid');

		$this->db->select('notices.id as id,notices.message as message');
		$this->db->join('notice_agent', 'notice_agent.notice_id = notices.id');
		$this->db->where('notice_agent.agent_extension', $extension);
		$this->db->where('notice_agent.agent_id', $agent_id);
		$this->db->where('notices.active', '1');
		$this->db->limit(1);
		$query = $this->db->get('notices');
		return $query->num_rows();
	}

	function agent_notice()
	{
		$this->db->where('active', '1');
		$this->db->limit(1);
		$query = $this->db->get('notices');
		$result = $query->row_array();
		return $result;
	}

	function get_inbound_agentname($ext = '')
	{
		if ($ext) {
			$this->db->where('extension', $ext);
			$this->db->where('status', 'READY');
			$this->db->where('calling_status', 'INCALL');
			$this->db->where('call_time is NOT NULL', NULL, FALSE);
			$query = $this->db->get('tmp_agent_status');
			$result = $query->row();
			return $result;
		}
	}

	function notices()
	{
		$this->db->where('status', '1');
		$this->db->order_by('id', 'DESC');
		$query = $this->db->get('notices');
		$result = $query->result();
		return $result;
	}

	function getIVRCall()
	{
		//$query = $this->db->get('tmp_ivr_cdr');
		$result = $this->db->count_all_results('tmp_ivr_cdr');
		return $result;
	}

	function call_history($caller = '')
	{
		$this->db->where('clid', $caller);
		$this->db->order_by('id', 'DESC');
		$this->db->limit(5);
		$query = $this->db->get('queue_cdr');
		$result = $query->result();
		return $result;
	}

	function getFreeAgents()
	{
		$query = $this->db->query("SELECT tas.agent_name AS agent_name,qn.id AS queue_number_auto_id, qn.queue_id AS queue_id, qn.number as number, qn.agent_status as agent_status, qn.status as status, qn.agent_id as agent_id, qn.call_order_type as call_order_type, qn.call_time as call_time FROM queue_numbers as qn INNER JOIN tmp_agent_status as tas ON qn.number = tas.extension WHERE tas.status = 'READY' AND tas.calling_status IS NULL AND tas.call_time IS NULL AND qn.status = 0 ORDER BY qn.call_time");
		return $query->result();
	}

	function get_pause_agent_list()
	{
		$this->db->where('status', 'PAUSE');
		$this->db->where('calling_status IS NULL');
		$this->db->order_by('last_updated_at', 'ASC');
		$this->db->order_by('extension', 'ASC');
		$query = $this->db->get('tmp_agent_status');
		$result = $query->result();
		return $result;
	}

	function get_queue_template_details($queue_template_id = '')
	{
		$this->db->where('template_id', $queue_template_id);
		$this->db->where('status', 1);
		$query = $this->db->get('queue_template');
		$resultObj = $query->row_array();
		return $resultObj;
	}

	function mail_read($id = '')
	{
		$this->db->where('id', $id);
		$this->db->update('adn_email', array('email_read' => 1));
	}

	function mail_attachments($id = '')
	{
		if ($id != '') {
			$this->db->where('email_id', $id);
			$query = $this->db->get('adn_email_attachment');
			return $query->result_array();
		}
		return false;
	}
}
