<div class="card">
	<div class="card-header">
		<h4 class="card-title">Email</h4>
		<button style="float: right; margin-top: -40px;" type="button" class="btn-close" aria-label="Close"
				id="email_close"></button>
	</div>
	<div class="card-body">
		<div>
			<div class="card">
				<div class="card-body">
					<div>
						<div style="font-weight: bold;" class="font-size-16">
							<?php echo $details['subject']; ?>
						</div>
					</div>
				</div>
			</div>
			<div class="mb-3" style="display: flex;">
				<button type="button" id="" class="btn btn-outline-dark">To</button>
				<input type="text" name="to" id="to" value="<?php echo $details['email_from_address']; ?>"
					   class="form-control" placeholder="To">
			</div>
			<div class="mb-3" style="display: flex;">
				<button type="button" id="" class="btn btn-outline-dark">Cc</button>
				<input type="text" name="cc" id="cc" value="<?php echo $details['email_cc_address']; ?>"
					   class="form-control" placeholder="Cc">
			</div>

			<div class="mb-3 email-editor">
				<textarea name="body" id="email_editor"></textarea>
			</div>
			<div class="mb-3">
				<label class="form-label" for="title">Attachments </label>
				<input type="file" id="attachments" class="form-control mt-1" multiple/>
				<div class="text-muted">Must be .wav/.mp3 file and size should be 2MB.</div>
			</div>
		</div>

		<input type="hidden" name="id" id="email_auto_id" value="<?php echo $details['id']; ?>">
		<button type="button" id="email_send" class="btn btn-primary">Send <i
				class="fab fa-telegram-plane ms-1"></i>
		</button>
	</div>
</div>
<div class="card">
	<div class="card-body">
		<div class="d-flex align-items-center mb-4">
			<!--<div class="flex-shrink-0 me-3">
											<img class="rounded-circle avatar-sm" src="assets/images/users/avatar-2.jpg"-->
			<!--								 alt="Generic placeholder image">
		</div>-->
			<div class="flex-grow-1">
				<h5 class="font-size-14 mb-0"><?php echo $details['email_from']; ?>
					<small
						class="text-muted font-size-14"><?php echo htmlentities("<") . $details['email_from_address'] . htmlentities(">"); ?></small>
				</h5>
			</div>
		</div>

		<?php echo nl2br($details['email_content']); ?>
		<hr/>
		<div class="row">
			<?php
			if (count($mail_attachments)) {
				foreach ($mail_attachments as $attachment) { ?>
					<div class="col-xl-2 col-6">
						<div class="card">
							<?php echo $attachment['email_attachment']; ?>
							<div class="py-2 text-center">
								<a href="<?php echo site_url('email/download/' . $attachment['email_attachment']); ?>"
								   class="fw-medium">Download</a>
							</div>
						</div>
					</div>
				<?php }
			}
			?>
		</div>
	</div>
</div>
<script src="<?php echo THEME_LIBS; ?>choices.js/public/assets/scripts/choices.min.js"></script>
<script>

	ClassicEditor.create(document.querySelector("#email_editor")).then(function (e) {
		e.ui.view.editable.element.style.height = "200px"
	}).catch(function (e) {
		console.error(e)
	});
	$(document).on('click', '#email_send', function (event) {
		event.preventDefault();
		var csrf_token = '<?php echo $this->security->get_csrf_hash(); ?>';

		var formData = new FormData();
		var files = $('#attachments')[0].files;

		// Append selected files to FormData
		for (var i = 0; i < files.length; i++) {
			formData.append('attachments[]', files[i]);
		}

		// Add additional parameters (if required)
		formData.append('to', $("#to").val());
		formData.append('cc', $("#cc").val());
		formData.append('body', $(".ck-content").text());
		formData.append('id', $("#email_auto_id").val());
		formData.append('csrf_callcenter_adn', csrf_token);
		$.ajax({
			type: "POST",
			url: "<?php echo base_url();?>email/reply_mail_agent/",
			data: formData,
			contentType: false,
			processData: false,
			success: function (response) {
				var obj = JSON.parse(response);

				if (obj.send) {
					$("#email").html("");
					$("#disposition_div").html("");
					$("#disposition_div").html(obj.disposForm);
					alert("Email Send Successfully.");
				} else {
					$("#email").html("");
					$("#disposition_div").html("");
					$("#disposition_div").html(obj.disposForm);
					alert("Email Send Failed.");
				}
			},
			beforeSend: function () {
				$(".spinner-container").show();
			},
			complete: function () {
				$(".spinner-container").hide();
			}
		});
	});
	// Initialize Choices.js dropdowns
	var textRemove = new Choices(
		document.getElementById("to"),
		{
			delimiter: ",",
			editItems: true,
			maxItemCount: 50,
			removeItemButton: true,
		}
	);
	var textRemove2 = new Choices(
		document.getElementById("cc"),
		{
			delimiter: ",",
			editItems: true,
			maxItemCount: 50,
			removeItemButton: true,
		}
	);
</script>
<style>
	.choices {
		width: 100%;
		margin-left: 5px;
	}
</style>
